// Open Source, private use only!
// Dr-Touchscreen Stellwerk nach DiMo (Digitale Modellbahn)
// EW kann Gleissperre sein
// Autoren F. Bollow, G. Krumm (LocoNet-Adaption)
// XDIM+1: wg. Felder am rechten Rand, Signal moeglich

#include "Loconet.h"
#ifndef LOCONET
#include <XpressNet.h>
XpressNetClass XpressNet;
//--------------------------------------------------------------------------------
// XpressNet address: must be in range of 1-31; must be unique. Note that some IDs
// are currently used by default, like 2 for a LH90 or LH100 out of the box, or 30
// for PC interface devices like the XnTCP.
#define XNetAddress 30    //Adresse im XpressNet
#define XNetSRPin 5       //Max485 Busdriver Send/Receive-PIN
//--------------------------------------------------------------------------------
#else
#include <LocoNet.h>
lnMsg   *LnPacket;
#define TASTER_G 11
#define TASTER_R 12
//#define LEDPIN 13
//#define RESETLINE 4
#define LN_TX_PIN 6
#define GRD_GRN 1
#define RND_ROT 0
#endif

#include <TimerOne.h>
#include <EEPROM.h>

#ifndef _csv_str_h
#define _csv_str_h
#include "csv_str.h"
#endif

#include "csvModul.h"

#ifndef _csvParser_h
#define _csvParser_h
#include "csvParser.h"
#endif

#include "DrawModul.h"
#include "RC_melder.h"

uint8_t CheckTarget(uint8_t xt, uint8_t yt);

extern void TurnoutLong(int fx, int fy, int corner, int colour);
extern void TrackSlant(int, int, int);
extern void TurnoutPos(int fx, int fy, int corner, int colour);
extern void DrawDiagonalStand(int fx, int fy, int SwStand);
extern void DrawSwitchStand(int fx, int fy, int SwStand);

extern void TurnoutDir(int fx, int fy, int Turn, int Colour);
extern void TrackLine  (int fx, int fy);
extern void TrackArrow (int fx, int fy, int corner);
extern void DrawSTurnout(int fx, int fy, int corner);
extern void DrawTurnout(int fx, int fy, int corner);
extern void TrackEdge(int fx, int fy, byte Edge);
extern void TrackLight (int fx, int fy, int Colour);
extern void CircleSig (int fx, int fy, int corner, int colour);
extern void Linie(int x1, int y1, int x2, int y2, int linecol);
extern void DrawPoly4 (int fx, int fy, int corner);
extern void TextKoord(void);
extern char DrawRectaF[];
extern char DrawFilCirc[];
extern void ShPicture (int fx, int fy, int corner, byte ShZeichen);
extern void ShHScreen(int, int, int);
extern void ShHPicture(int, int, int, byte);
extern void PosLight(int fx, int fy, int colour);
extern void KreuzWaager(int x, int y, int colour);

extern void DrawDWstand(int fx, int fy, int Lage);
extern void ShowEraseLageDW(int fx, int fy, uint16_t color);

extern void InitDKWabcd(int fx, int fy);
extern void CmpSetDKW(int fx, int fy, uint8_t DKWab_cd, uint8_t Lage);
extern void DrawDKWstand(int fx, int fy, int Lage);
extern uint8_t GetLageDKWabcd(int fx, int fy);
extern void Init1ADKW(int fx, int fy);
extern uint8_t GetLageDKWcd(int fx, int fy);

extern int  TouchNotify(void);
extern void Text_CR(int);
extern void AnzeigeXY(byte, byte, byte);
extern void AnzeigeEle(byte, byte);
extern void AnzeigeBM(byte, byte);
extern void i2str(byte flg, int i);
extern void CircleF (int fx, int fy, int rad, int colour);
extern void CircleFB (int fx, int fy, int rad, int colour);
extern void TouchGet (int mode);
extern void TouchSet (int mode);
extern void TouchFieldAll(void);

extern void uart3dOut(uint8_t);
extern void uart3init(void);
extern void RCFetch(void);

// Testhilfen im Modul Debug
extern void SigDump(void);
extern void CheckLinkArray(void);
extern void LinkTest(void);
extern void CheckRMArray(void);
extern void BMdump(void);
extern void BMZustandDump(void);
extern void FWegDump(void);
extern void AdrDump(void);
extern void QueDump(void);
extern void TheKeys(void);
extern void Fliste(int16_t);
extern void Tracker(uint8_t x, uint8_t y, uint8_t Ele);
#ifndef LOCONET
extern void Debug32(uint8_t valH, uint8_t valL, uint8_t val3);
#else
extern void Debug32(uint16_t Address, uint8_t Direction);
#endif

#define ledpin 13
#define RESETLINE 4

extern char BackGround[];
extern char ClearScreen[];
extern char TextColourYe[];
extern char TextHeight[];
extern char TextRCBackGd[];

//----------------------------------------------------------------

//uint8_t ar1[1000] = {0,1,2}; // nur Speicherplatz, wenn Zugriff und Prog. global

bool Dauertest = false;

uint8_t pruef = 0;

char stri[20] = "Bollow";
int slen = strlen(stri);

bool    Answer = false;
bool    Flag   = false;
uint8_t GL_cnt = 0;

#ifndef LOCONET
uint8_t GL_XBusAdr = XNetAddress; // default
uint8_t GL_XBusWait = 0; // Start Delay
#else
uint8_t DisplayBaud = BaudIndex;
#endif
uint8_t GL_DebOpt  = 0;

uint8_t GL_xmax = 0;      // fuer Erkennung 4,3" oder 7"
uint8_t GL_ymax = 0;      // Werte durch csvParser.cpp

int     GL_pixXmax = 479; // default Display small
int     GL_pixYmax = 271;

#define BFDIM 28
KYITEM ButtField[BFDIM] = {0, 0};

byte    GL_ButtCnt = 0;  // Anzahl der Buttons
byte    GL_ButtPos = 0;  // Aktiver Button

byte    GL_Wx = 0;
byte    GL_Wy = 0;

uint8_t GL_sqButtX = 0; // Koord. für Taste mit Wechseltext
uint8_t GL_sqButtY = 0;
bool    GL_sqExist = false;

int     xpos = 0; // Koord. im Anzeigefeld
int     ypos = 0;

byte    GLOB_FwegAuftrag = 0;
int     GL_rval          = 0;
byte    GL_SiHalt        = 0;

uint8_t GL_DKWcdState    = 0;

// EEP Str im RAM
uint8_t RAM_EEPstr [hdDIM] = {0};

// Pult Variablen: PV0 - PV15 (zunächst PV0 - PV9 aenderbar duch user)
uint8_t PultPV[hdDIM] = {0};

// jeweils die gesamte Fläche wird abgebilder
// not char !!
uint8_t StpM[YDIM][XDIM + 1] = {{0}  // Elemente mit Drehungen, nach init 3 Bits MSB für Lage
};

uint16_t StpA[YDIM][XDIM + 1] = {{0} // Adressen Digital, Matrix ist für jede Adresse gut
};      // Adr. 11 Bits, 2 Bits opt. Switch delay, 1 bit Switch Swap

uint8_t StpS[YDIM][XDIM + 1] = {{0}  // Signal und Lage
};

// ------- Link Liste ----------------
uint8_t Linkxy[4][LDIM] = {0}; // hint: {0,0,0,0} doesn´t work. x,y,x1,y1
uint8_t Lresult[3]      = {0}; // 0:x, 1:y, 2: Eingang
// -----------------------------------

// #define AnzWeichen 32
WITEM Weiche[AnzWeichen] = {{0, 0, 0, 0, 0, "Empty"}};

#ifndef LOCONET
uint8_t  XBusQueue[XQDIM] = {0};
uint16_t WRptr            =  0;
uint16_t RDptr            =  0;
#define  PTRMSK            XQDIM-1  // 64 Bytes, Maske 0x3F
#endif
// Queue-Inhalt (Bytes): Hadr, Ladr, Value, Null (ggf.Delay)
// Delay wg. Verlaengerung Umstellzeit (0,1,2,3)

#define YFnum   20      // max. Anzahl Fahrwege

int16_t Fweg[YFnum][XWnum] = {{0}}; // Vorzeichen ist Lage (+/-)
uint8_t  GL_AnzFweg = 0; // tarsaechliche Fweg Anzahl
byte     check = 0;

bool GL_TouchLock = false;

// Melder ------------------------------------------------
#define MEDIM 10
MEITEM Melder[MEDIM] = {0, 0, 0, false};
/*
#define indicTFdb 1  // Touchfeedback
#define indicRun  2  // Run (blinker)
#define indicTPwr 3  // Trackpower
#define indicBusy 4  // Zentrale Busy
*/
// Melder Blau und Gruen auch Taste
uint8_t GL_RouteClass = 0;          // globale #defines müssen in einem Header-File stehen

uint8_t GL_SigZR      = 0;
#define SIGZRMAX  1

uint8_t GL_DKW_abcd   = 0;
#define DKWMAX    1

uint8_t GL_Rx = 0;  // Zugesteuerte Fstr. Aufloesung
uint8_t GL_Ry = 0;

uint8_t GL_Richtung = 0;  // Wegverfolgung

// Melder ------------------------------------------------

// Rueckmelder -------------------------------------------

uint8_t RMmax = 0;     // incr. beim Lesen aus csv
#ifdef LOCONET
#ifndef STANZLN
uint8_t  StaLN  = 0;
#endif
uint16_t RMoff1 = 0;
uint16_t RMoff2 = 8;
uint8_t  RMsts  = 0;
uint8_t  RMlnt  = 0;
uint8_t  RMpin[RMDIM] = {22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37};
#endif

RMITEM RMKoord[RMDIM] = {0, 0, 0, 0, 0, 0}; // struct in csvParser.h
//  x y r r B R
uint8_t GL_BMsim = 0;  // Simulation Belegtmelder wenn 1

// Rueckmelder -------------------------------------------

char bingo[20] =  "0 Bingo 0123456789 ";

char str[] = {__FILE__};
int  fslen = strlen(str);

char datum[40] = __DATE__;
int  dlen = strlen(datum);

#define FLDIM 10
char FirstLine[FLDIM] = {""};


char buf = ' ';
int  deb = 0; // Debug

#define t01sec    10
#define t02sec    20
#define t05sec    50
#define t09sec    90
#define  t1sec   100
#define  t1_1sec 110
#define  t2sec   200
#define  t3sec   300
#define  t5sec   500
#define t10sec  1000
#define t20sec  2000
#define t40sec  4000
#define  t1min  6000
#define  t2min 12000
#define  t5min 30000
#define t10min 60000

volatile unsigned long int tickerT1 = 0UL;
unsigned long int startzeitA = 0UL;   // TrackContacts, Fahrwegliste
unsigned long int startzeitB = 0UL;   // LifeTicker, Meldefelder update
unsigned long int startzeitC = 0UL;   // XpressNet, update the library
unsigned long int startzeitD = 0UL;   // Bediensperre (Sync. Anzeige/Stellkommando)
unsigned long int startzeitE = 0UL;

bool    GL_unbefahrbar = false;
uint8_t GL_KreuzungInfo = 0;
uint8_t GL_Bediensperre = 0;

// --------------------------------------------------------------
// Wegverfolgung
// --------------------------------------------------------------
struct mys { // Weichenelemente
  uint8_t plus;  // Lage
  uint8_t minu;
};

struct myd { // Doppelweiche
  uint8_t oben;
  uint8_t mitte;
  uint8_t unten;
};

struct myk { // DKW
  uint8_t pabpcd;
  uint8_t pabmcd;
  uint8_t mabpcd;
  uint8_t mabmcd;
};

// Formatierung mit Leerzeichen hier nicht veraendern! Ist Software-Dku.

#define IDIM 7  // 6 Tracking Positionen + index 0

// a[Element][kommtVon], Index 0 not in use
mys TS[][IDIM] =
          { {{0, 0}, {1, 0}, {0, 1}, {0, 0}, {4, 5}},                 //0 8
            {{0, 0}, {0, 0}, {0, 3}, {3, 0}, {0, 0}, {0, 0}, {6, 5}}, //1 9
            {{0, 0}, {1, 2}, {0, 0}, {0, 0}, {4, 0}, {0, 4}},         //2 10
            {{0, 0}, {0, 0}, {0, 0}, {3, 2}, {0, 0}, {0, 6}, {6, 0}}, //3 11
            {{0, 0}, {0, 0}, {2, 1}, {0, 0}, {0, 5}, {5, 0}},         //4 16
            {{0, 0}, {0, 0}, {2, 3}, {0, 0}, {0, 0}, {5, 0}, {0, 5}}, //5 17
            {{0, 0}, {0, 2}, {2, 0}, {0, 0}, {0, 0}, {5, 4}},         //6 18
            {{0, 0}, {0, 0}, {2, 0}, {0, 2}, {0, 0}, {5, 6}, {0, 0}}, //7 19
            {{0, 0}, {1, 2}, {2, 1}, {0, 0}, {4, 5}, {5, 4}},         //8 12 DKW 1 An.
            {{0, 0}, {0, 0}, {2, 3}, {3, 2}, {0, 0}, {5, 6}, {6, 5}}, //9 13 DKW 1 An.
}; //   Index  (0)     1        2       3       4       5       6
   //    Ele           4        5       6       1       2       3

myk TK[][IDIM] = 
          { {{0,0,0,0},{0,0,2,1},{2,1,0,0},{0,0,0,0},{0,5,0,4},{5,0,4,0}},           //0 12 DKW
            {{0,0,0,0},{0,0,0,0},{2,3,0,0},{0,0,2,3},{0,0,0,0},{5,0,6,0},{0,5,0,6}}, //1 13 DKW 
}; //   Index  (0)         1         2         3         4         5         6
   //    Ele               4         5         6         1         2         3   
   
myd TD[][IDIM]      =
      { {{0, 0, 0}, {2, 0, 0}, {0, 2, 0}, {0, 0, 2}, {0, 0, 0}, {4, 5, 6}, {0, 0, 0}}, // 0 24
        {{0, 0, 0}, {0, 0, 0}, {3, 2, 1}, {0, 0, 0}, {0, 0, 5}, {0, 5, 0}, {5, 0, 0}}, // 1 25
}; // Index (0)         1           2         3           4         5           6
// Bsp.: Ele=25, Quelle ist Ausgang 4 (Index), wenn Lage unten, dann ist 1 Ausgang
//               Quelle ist Ausgang 2 (Index), Ausgang 3 od. 2 od. 1 nach Lage

uint8_t TG[][IDIM] = { // Elemente ohne Lageinformation
  // Input ist Element (Zeile) und Ausgang vorheriges Element Spalte
  // durch Zugriff entsteht der neue Ausgang

  {0, 0, 2, 0, 0, 5, 0}, //0 Gerade, 1,2,3
  {0, 0, 1, 0, 5, 0, 0}, //1 Knick 4
  {0, 0, 3, 0, 0, 0, 5}, //2 Knick 5
  {0, 2, 0, 0, 0, 4, 0}, //3 Knick 6
  {0, 0, 0, 2, 0, 6, 0}, //4 Knick 7
  {0, 1, 0, 0, 4, 0, 0}, //5 Diagonale 20
  {0, 0, 0, 3, 0, 0, 6}, //6 Diagonale 21
  {0, 1, 2, 0, 4, 5, 0}, //7 Kreuzung 22
  {0, 0, 2, 3, 0, 5, 6}, //8 Kreuzung 23
  {0, 1, 0, 3, 4, 0, 6}, //9 Kreuzung 15 sym.
};

struct {  // Folgekoordinaten
  int8_t nX;
  int8_t nY;   // 0,0 not used
} FK[IDIM] = {{0, 0}, {1, 1}, {1, 0}, {1, -1}, { -1, -1}, { -1, 0}, { -1, 1}};

// Element wird Array-Zugriff
uint8_t IndexKor[] = 
    {0, 0, 0, 0, 1, 2, 3, 4, 0, 1, 2, 3, 0, 1, 0, 9, 4, 5, 6, 7, 5, 6, 7, 8, 0, 1};
//      1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
//     | gerade |  Knicke   |  Weichen | DKW |  |Kr| Weichen   |Diag |Kreuz| DW  |
// 1->0
// 2->0
// 3->0
// 4->1
// 5->2

// --------------------------------------------------------------

// gueltig fuer Weichenlagen, nicht fuer Streckenteile
#define FSTRAUFB 0xE0  // Maske Weichenlage und Belegt mit Fstr.
#define FSTRABBA 0xC0  // Maske Weichenlage

// --------------------------------------------------------------
//                FstrPruefer
// --------------------------------------------------------------

// Prueft auf Belegt-Flag, nur vor Fstr.Aufbau

uint8_t  FstrPruefer(uint8_t xko, uint8_t yko) {

  uint8_t  Frei      = 1;
  uint8_t  Ele       = 0;
  uint8_t  LastEle   = 0;
  int8_t   nextx     = 0;
  int8_t   nexty     = 0;
  uint8_t  FremdEin  = 5; // default nach links
  uint8_t  EigenAus  = 0;
  uint8_t  Sig       = 0;
  uint8_t  Tst       = 255;
  //uint8_t  Richtung  = 0; // Sig unten, -> 0
  uint8_t  cnt       = 0;
  uint8_t  Anfang    = 1;

  Serial.println();   Serial.println();
  Serial.println(F(" -> Fstr. Pruefer erstes Element:"));

  // 2. Element lesen StpM[][]
  Ele = StpM[yko][xko];               // prueft StpM[][], also Gleis (1,2,3) nicht Signal
  Tracker(xko, yko, Ele);

  if (Ele & FSTRBEL) {
    Frei = 0;  // bereits belegt mit Fstr.
    FInfo(0);
    return (Frei);
  }


  // 3. Richtungsbestimmung (Startsignal)
  Sig = (StpS[yko][xko]) & 0x1F ;    // liest StpS[][], also Signal
  switch (Sig) {

    case 30:
    case 28:
    case 26: FremdEin = 2;
      GL_Richtung = 0;
      break;
    case 31:
    case 29:
    case 27: FremdEin = 5;
      GL_Richtung = 1;
      break;
    default:
      break;
  }

  do
  {
    cnt++; //Serial.print("cnt ");Serial.print(cnt);Serial.print(' ');

    GetDKWcdState(xko, yko);
    // 4.  eigenen Ausgang bestimmen
    EigenAus = EigenOut(Ele, FremdEin, FSTRAUFB);

    if (GL_DebOpt & 0b00010000)  {  // 16
      Serial.print(__LINE__); Serial.print(' '); Serial.print(GL_unbefahrbar);
      Serial.print(F(" Eigenaus: "));  Serial.println(EigenAus);
    }

    if (GL_unbefahrbar) {
      FInfo(0);
      return (0);
    }

    if (!EigenAus) {
      Frei = 0;
      FInfo(0);
      return (Frei);
    };

    // Kein Draw

    // 5. Folgekoordinaten bestimmen
    nextx = xko + FK[EigenAus].nX;
    nexty = yko + FK[EigenAus].nY;

    //if (!StpM[nexty][nextx]) {  // leer?
    //   Serial.println(F("Pruefer: Leer"));
    //   return 1;
    //}

    // Einschub Link -----------------------------------------------------
    if (!Anfang) {                // Beim Start kein Link zulaessig
      if (LinkSearch(xko, yko)) {
        EigenAus = CheckTarget(Lresult[0], Lresult[1]);
        Serial.print(F("Link x,y: ")); Serial.print(Lresult[0]); Serial.print(','); Serial.println(Lresult[1]);
        if (EigenAus) {
          nextx = Lresult[0] + FK[EigenAus].nX;  // Jump new location
          nexty = Lresult[1] + FK[EigenAus].nY;
        }
      }
    }
    // Ende Einschub Link -----------------------------------------------

    switch (StpM[nexty][nextx] & 0x1F) {  // leer oder Diagonale?
      case  0:
      case 20:
      case 21:
        Serial.println(F("Pruefer: Leer/Diagonale"));
        return 1;
        break;
      default:
        break;
    }

    Anfang = 0;

    if ((nextx < 0) || (nextx > GL_xmax)) {
      Frei = 1;
      Serial.print(__LINE__);
      FInfo(1);
      break;
    };
    if ((nexty < 0) || (nexty > GL_ymax)) {
      Frei = 1;
      Serial.print(__LINE__);
      FInfo(1);
      break;
    };

    LastEle = Ele;

    // next -----------------------------------------------
    // 6. Folgeelement lesen, Matrix StpM[][]
    Ele  = StpM[nexty][nextx];
    Tracker(nextx, nexty, Ele);

    if (GL_RouteClass >= 3) { // wenn R(angier) keine Belegtpruefung
      switch (Ele & 0x1F) { // Streckenelement?
        case 1:
        case 2:
        case 3: if ((!GL_SigZR) && (Ele & DETECTSET)) return (0);
          break;
        default:
          break;
      } // switch
    } // if RCL

    Sig  = (StpS[nexty][nextx]) & 0x1F ;  // ggf. ein Signal
    // ------------------------------------------------------
    GetDKWcdState(nextx, nexty);
    Tst = EigenOut(Ele, EigenAus, FSTRAUFB);

    if (GL_DebOpt & 0b00010000)  {
      Serial.print(__LINE__); Serial.print(F(" ")); Serial.println(GL_unbefahrbar);
    }
    if (GL_unbefahrbar) {
      FInfo(0);  // diese Zeile notwendig bei TEm, Sig A, Sig Y
      return (0);
    }
    //Serial.print("Tst Eigenout() ");Serial.println(Tst);

    if ((Ele == 22) || (Ele == 23)) {
      GL_KreuzungInfo = Tst; // Diagonal: 3/6 oder 1/4, Waager. 2/5 oder 5/2
    }

    if (Tst == 0) {
      Tracker(nextx, nexty, Ele);
      if (GL_DebOpt & 0b00010000)  {
        Serial.print(F(" LastEle: ")); Serial.println(LastEle);
      }
      switch (LastEle & 0x1F) {
        case 1:
        case 2:
        case 3: switch (Ele & 0x1F) {
            case 20:              // Diagonale
            case 21: return (1);
            case  4:              // Knicke
            case  5: if (GL_Richtung) return (1); // von rechts
            case  6:
            case  7: if (!GL_Richtung)return (1); // von links
            case  8:              // Diagonale Weichen
            case  9: if (GL_Richtung) return (1); // von rechts
            case 10:
            case 11: if (!GL_Richtung)return (1); // von links
              break;
            default:
              break;
          }
        default:
          break;
      } // switch
      return (0);   // BREAK
    }

    // bis hier ist Ele unmaskiert, d.h. Weicheninfo ist anders als Streckeninfo!
    if ((Ele & 0x1F) > 3) {
      if (Ele & FSTRBEL) {
        return (0); // BREAK
      }
    }
    else { // Streckenelement 1, 2, 3
      // Fstr.Anschluss, wenn Fstr.Start nicht FSTRBEL prüfen
      if (Ele & FSTRSTART)      {
        return (1); // BREAK
      }
      else {
        if (Ele & FSTRBEL) {
          return (0); // BREAK
        }
      }
    }

    // ------------------------------------------------------
    if (GL_RouteClass >= 2) {                    // bei RCL = 1, langer Weg ohne Zwischensignale
      if (((Sig == 28) || (Sig == 30) || (Sig == 26)) && (!GL_Richtung)) {
        Frei = 1;
        Serial.print(__LINE__);
        FInfo(1);
        return (Frei);
      }

      if (((Sig == 29) || (Sig == 31) || (Sig == 27)) &&  (GL_Richtung)) {
        Frei = 1;
        Serial.print(__LINE__);
        FInfo(1);
        return (Frei);
      }

    }                                            // bei RCL >= 2 Fstr.Ende am Folgesignal

    FremdEin = EigenAus;

    // 9. istKoord. aus ehem. nextKoord setzen
    xko = nextx;
    yko = nexty;

  } while (1);

  return (Frei);
} // FstrPruefer()


// --------------------------------------------------------------
// Bestimmung von Eingang und Ausgang
// --------------------------------------------------------------

uint8_t CheckTarget(uint8_t xt, uint8_t yt) {
  uint8_t EleL = StpM[yt][xt - 1] & 0x1F;
  uint8_t EleT = StpM[yt][xt]   & 0x1F;
  uint8_t EleR = StpM[yt][xt + 1] & 0x1F;
  uint8_t Ein  = 0;
  uint8_t Aus  = 0;

  if (GL_DebOpt & 0b00010000)  {
    Serial.print(F("Target ist: ")); Serial.println(EleT);
  }

  switch (EleT) {
    case 1:
    case 2:
    case 3: if (EleL)  {
        Ein = 5;
        GL_Richtung = 1;
      }
      else  {
        Ein = 2;
        GL_Richtung = 0;
      }
      break;

    case 4:
    case 5: Ein = 2;
      GL_Richtung = 0;
      break;
    case 6:
    case 7: Ein = 5;
      GL_Richtung = 1;
      break;

    default:
      break;
  }

  if (Ein) {
    GetDKWcdState(xt, yt);
    Aus = EigenOut(EleT, Ein, FSTRAUFB);
    if (GL_DebOpt & 0b00010000)  {
      Serial.print(F("Ausgang Target ist: ")); Serial.println(Aus);
    }
  }
  else     {
    Serial.println(F("kein Ausgang."));
    Aus = 0;
  }
  Lresult[2] = EleT;
  Lresult[3] = Ein;
  return (Aus);
} // CheckTarget()

// --------------------------------------------------------------


// Starten durch newCheckSignal() für Aufbau und Aufloesung der Fstr.
// Setzen/Ruecksetzen des BelegtMitFstr -Flag

uint8_t Verfolger(uint8_t xko, uint8_t yko) {
  //       1. Startkachel x,y

  uint8_t  Ele       = 0;
  int8_t   nextx     = 0;
  int8_t   nexty     = 0;
  uint8_t  FremdEin  = 5; // default nach links
  uint8_t  EigenAus  = 0;
  uint8_t  error     = 0;
  uint8_t  Sig       = 0;
  uint16_t colour    = YELLOW;
  uint8_t  StartX    = xko;
  uint8_t  StartY    = yko;
  bool     Erfolg    = true;
  uint8_t  Maske     = 0;
  //uint8_t  Richtung  = 0; // Sig unten, ->
  uint8_t Tst = 255;
  uint8_t  Abbruch   = 0;
  uint8_t  Anfang    = 1;

  // 2. Element lesen StpM[][]
  Ele = StpM[yko][xko];

  // Zugesteuerte Aufloesung, Anfang
  GL_Rx  = xko; // fuer Zuggesteuerte Fahrstrassenaufloesung
  GL_Ry  = yko; // Zwischenablage, bis Ziel bekannt, dort Ablage in RMKoord[].

  if (Ele & FSTRSTART) { // Fstr. exist Fstr. Abbau Fahrstrasse
    StpM[yko][xko] = Ele & FSTRTRATS;
    Maske          = FSTRABBA;
    colour         = DGRAY;
  }
  else {           // Fstr. Aufbau Fahrstrassenstart
    StpM[yko][xko] = Ele | FSTRSTART;
    Maske          = FSTRAUFB;
    colour         = YELLOW;
  }

  Ele = StpM[yko][xko]; // Hall of Fame ...

  if  (colour == YELLOW) {
    StpM[yko][xko] = Ele | FSTRBEL; // wg. Anschlusstechnik,wenn Beginn Fstr.,kein Lockbit
    Serial.print(F("@ Aufbau "));
  }
  else {
    StpM[yko][xko] = Ele & FSTRFREI;   // Bei FSTRSTART nicht FSTRFREI setzen
    Serial.print(F("@ Abbau "));
  }


  // 3. Richtungsbestimmung (Startsignal)
  Sig = (StpS[yko][xko]) & 0x1F ;
  switch (Sig) {

    case 26:
    case 30:
    case 28: Serial.println(F("Signal unten"));
      GL_Richtung = 0;
      FremdEin = 2;
      break;
    case 27:
    case 31:
    case 29: Serial.println(F("Signal oben"));
      GL_Richtung = 1;
      FremdEin = 5;
      break;
    default:
      break;
  }

  Tracker(xko, yko, StpM[yko][xko]); // 1.Element

  Ele = StpM[yko][xko]; // Ele aktuell

  // ----------------- do-Loop -----------------------------------------
  do
  { if (!(Ele & 0x1F)) {
      error = 4;
      break;
    };           // BREAK

    GetDKWcdState(xko, yko);
    // 4.  eigenen Ausgang bestimmen
    EigenAus = EigenOut(Ele, FremdEin, Maske);
    if (GL_DebOpt & 0b00010000) {
      Serial.print(__LINE__); Serial.print(F(" ")); Serial.println(GL_unbefahrbar);
    }
    if (!EigenAus) {
      error = 1;
      break;
    };               // BREAK

    FstrDraw(xko , yko, Ele, FremdEin, colour); // hier Farbwechsel bei Gleis besetzt/frei

    if (Abbruch) {  // Zielelement noch gelb zeichnen
      StpM[yko][xko] = Ele & FSTRFREI; // Bei FSTRSTART nicht FSTRFREI setzen
      error = 5; break;
    }  // wg. RCL 2                // BREAK

    // 5. Folgekoordinaten bestimmen
    nextx = xko + FK[EigenAus].nX;
    nexty = yko + FK[EigenAus].nY;

    // Einschub Link -----------------------------------------------------
    if (!Anfang) {                // Beim Start kein Link zulaessig
      if (LinkSearch(xko, yko)) {
        EigenAus = CheckTarget(Lresult[0], Lresult[1]);
        Serial.print(F("Link x,y: ")); Serial.print(Lresult[0]); Serial.print(','); Serial.println(Lresult[1]);
        FstrDraw(Lresult[0], Lresult[1], Lresult[2], Lresult[3], colour);

        Sig  = StpS[Lresult[1]][Lresult[0]] & 0x1F;
        if (Sig) {
          Serial.print(F("Sig,x,y: ")); Serial.print(Sig); Serial.print(',');
          Serial.print(Lresult[0]); Serial.print(',');
          Serial.print(Lresult[1]); Serial.println();
        }
        switch (Sig) {
          case 26:
          case 28:
          case 30: if (Lresult[3] == 2) {
              if (colour == YELLOW) SignalHp1(Lresult[0], Lresult[1]);
              else                  SignalHp0(Lresult[0], Lresult[1]);
            }
            break;
          case 27:
          case 29:
          case 31: if (Lresult[3] == 5) {
              if (colour == YELLOW) SignalHp1(Lresult[0], Lresult[1]);
              else                  SignalHp0(Lresult[0], Lresult[1]);
            }
            break;
          default: break;
        } // switch Sig

        if (EigenAus) {
          nextx = Lresult[0] + FK[EigenAus].nX;  // Jump new location
          nexty = Lresult[1] + FK[EigenAus].nY;
        }
      }
    }
    // Ende Einschub Link -----------------------------------------------

    Anfang = 0;                 // Link zulaessig

    if ((nextx < 0) || (nextx > GL_xmax)) {
      error = 2;
      break;
    };  // BREAK
    if ((nexty < 0) || (nexty > GL_ymax)) {
      error = 3;
      break;
    };  // BREAK

    // XDIM, YDIM ist immer 7",
    // next -----------------------------------------------

    // 6. Folgeelement lesen, Matrix StpM[][]
    Sig  = (StpS[nexty][nextx]) & 0x1F ;
    Ele  =  StpM[nexty][nextx];

    GetDKWcdState(nextx, nexty);
    Tst = EigenOut(Ele, EigenAus, Maske);

    if (GL_DebOpt & 0b00010000) {
      Serial.print(__LINE__); Serial.print(F(" ELE: ")); Serial.print(Ele);
      Serial.print(F(" Tst ")); Serial.println(Tst);
    }
    if (Ele == 0) {
      error = 0;  // Stumpfgleis, kein Folgeelement, beim Belegen Fstr. Aufl.
      break;
    }
    // Aber, wenn statt 0 Diagonale, dann fehlerhaft !!!!!!!!!
    // vielmehr ist festzustellen, das Kein Anschluss besteht

    if ((Ele == 22) || (Ele == 23)) {

      GL_KreuzungInfo = Tst; // Diagonal: 3/6 oder 1/4, Waager. 2/5 oder 5/2
    }

    if (Tst == 0) {
      error = 1;
      break;
    };                  // BREAK


    if (GL_RouteClass >= 2) {
      if (colour == YELLOW) {
        StpM[nexty][nextx] = Ele | FSTRBEL;

        Tracker(nextx, nexty, StpM[nexty][nextx]);

        switch (Sig) {
          case 26:
          case 28:
          case 30: if (!GL_Richtung) Abbruch = 1;
            break;
          case 27:
          case 29:
          case 31: if (GL_Richtung) Abbruch = 1;
            break;
          default: break;
        } // switch Sig
      }   // if yellow

      else {
        StpM[nexty][nextx] = Ele & FSTRFREI; // Bei FSTRSTART nicht FSTRFREI setzen
        switch (Sig) {
          case 26:
          case 28:
          case 30: if (!GL_Richtung) Abbruch = 1;
            break;
          case 27:
          case 29:
          case 31: if (GL_Richtung) Abbruch = 1;
            break;
          default: break;
        } // switch Sig
      }
    } // if RouteClass >= 2

    else { // RouteClass < 2
      if (colour == YELLOW) {
        StpM[nexty][nextx] = Ele | FSTRBEL;

        Tracker(nextx, nexty, StpM[nexty][nextx]);

        switch (Sig) {
          case 26:
          case 28:
          case 30: if (!GL_Richtung) SignalHp1(nextx, nexty);
            break;
          case 27:
          case 29:
          case 31: if (GL_Richtung) SignalHp1(nextx, nexty);
            break;
          default: break;
        } // switch Sig
      }   // if yellow

      else {
        StpM[nexty][nextx] = Ele & FSTRFREI; // Bei FSTRSTART nicht FSTRFREI setzen

        switch (Sig) {
          case 26:
          case 28:
          case 30: if (!GL_Richtung) SignalHp0(nextx, nexty);
            break;
          case 27:
          case 29:
          case 31: if (GL_Richtung) SignalHp0(nextx, nexty);
            break;
          default: break;
        } // switch Sig
      }
    } // else RouteClass < 2

    FremdEin = EigenAus;

    // 9. istKoord. aus ehem. nextKoord setzen
    xko = nextx;
    yko = nexty;

  } while (1);

  // zuggesteuerte Fstr. Aufloesung >>>>>>>>>>>> nur für Border oder Sig., nicht f. Stumpfgleis
  uint8_t i = suche_i(xko, yko);

  if (GL_DebOpt & 0b00010000) {
    Serial.print(__LINE__); Serial.print(F(" Verfolger i = ")); Serial.println(i);
  }

  // i kommt mit korr. Wert, also 1 - 24 (oder -1). Beim Array Zugriff muss dann doch wohl (i-1) erfolgen

  if (i > 0) {   // Matrix Dim. ist 24, also ind. 0-23
    RMKoord[i - 1].Rx = GL_Rx;
    RMKoord[i - 1].Ry = GL_Ry;
    GL_Rx = 0;
    GL_Ry = 0;
  } // if

  // plausibel?
  if (colour == YELLOW) {

    Serial.println();

    Serial.print(F("@ Belegung von x,y ")); Serial.print  (xko), Serial.print(' ');
    Serial.println(yko);
    Serial.print(F("@ Aufloes.  ab x,y ")); Serial.print  (RMKoord[i - 1].Rx), Serial.print(' ');
    Serial.println(RMKoord[i - 1].Ry);
  }
  if (GL_DebOpt & 0b00001000) { // 8
    Serial.print(' '); Serial.println(__LINE__); CheckRMArray();
  }

  switch (error) {
    case 0:  Serial.println(F("ok "));  break;
    case 1:  Serial.println(F("no match")); Erfolg = false; break;
    case 2:  Serial.println(F("border x")); break;
    case 3:  Serial.println(F("border y")); break;
    case 4:  Serial.println(F("End of line")); break;
    case 5:  Serial.println(F("Signal in Fahrtrichtung")); break;
    default:
      break;
  }
  return (Erfolg);

  // --------------------------------------------------------------
} // Verfolger()


uint8_t LinkSearch(uint8_t x, uint8_t y) {
  Lresult[0] = 0;
  Lresult[1] = 0;

  for (int k = 0; k < LDIM; k++) {
    if ((Linkxy[0][k] == x) && (Linkxy[1][k] == y)) {
      Lresult[0] = Linkxy[2][k];
      Lresult[1] = Linkxy[3][k];
      return 1;
    }
    if ((Linkxy[2][k] == x) && (Linkxy[3][k] == y)) {
      Lresult[0] = Linkxy[0][k];
      Lresult[1] = Linkxy[1][k];
      return 1;
    }
  } // for
  return 0;
} // LinkSearch()


void FInfo(uint8_t Flg) {  // Ausgabe von ok/nok im Melderfeld 1, 0
  switch (Flg) {
    case 0: if (Melder[6].exist) TextInfoPos(Melder[6].x, Melder[6].y, "> nok  ", 5, 0);
      break;
    case 1: if (Melder[6].exist) TextInfoPos(Melder[6].x, Melder[6].y, "> ok       ", 5, 0);
      break;
    default:
      break;
  }
} // FInfo()


void GetDKWcdState(int fx, int fy) {
// notwendig, da EigenOut() nicht x, y-Koord. kennt
// holt Bit für DKW ein Antrieb und Lage cd
//        cdab
       // 0101  5 ++
       // 0110  6 +-
       // 1001  9 -+
       // 1010 10 --  
switch (StpM[fy][fx] & 0x1F) {  
  case 12:
  case 13:
     uint8_t Lage_abcd = GetLageDKWabcd(fx, fy);
     if (StpA[fy][fx] & ADR1DKW) { // if DKW ein Antrieb
        Lage_abcd = Lage_abcd | 0x80;
        }
     GL_DKWcdState = Lage_abcd;
     break;
  default:
       GL_DKWcdState = 0; 
     break;
  } // switch  
} // GetDKWcdState()


uint8_t EigenOut(uint8_t Ele, uint8_t FremdEin, uint8_t AufAb) {
  uint8_t ind      = 0;
  uint8_t EigenAus = 0;
  uint8_t LageDW   = Ele >> 6;
  // Maske Aufbau 0xE0, Abbau 0xC0

  GL_unbefahrbar = false;;

  ind = IndexKor[Ele & 0x1F];

  switch (Ele & 0x1F) {
    case   1:  // Elemente ohne Lageinformation
    case   2:
    case   3:  // gerade
    case   4:
    case   5:
    case   6:
    case   7:  // Knicke
    case  15: // sym. Kreuzung
    case  20:
    case  21: // Diagonale
    case  22:
    case  23: // Kreuzung
      EigenAus = TG[ind][FremdEin]; // gesuchtes Ele. matching ... ?
      break;

    case  8:  // einfache Weichen
    case  9:
    case 10:
    case 11:

    case 16:
    case 17:
    case 18:
    case 19:
      switch (Ele & AufAb) {
        case 0x80:   // abzweigend, -
          EigenAus = TS[ind][FremdEin].minu;
          break;

        case 0x40:   // gerade, +
          EigenAus = TS[ind][FremdEin].plus;
          break;

        default:     // unbefahrbar bzw. gesperrt
          Serial.println(F("unbefahrbar "));
          GL_unbefahrbar = true;
          EigenAus = 0;
          break;
      }
      break;

    case 12: // DKW 
    case 13:
      if (GL_DKWcdState & 0x80) { // DKW mit einem Antrieb
          if ((Ele & 0x1F) == 12) ind = 8;
          else                    ind = 9;
      switch (Ele & AufAb) {
        case 0x80:   // abzweigend, -
          EigenAus = TS[ind][FremdEin].minu;
          break;

        case 0x40:   // gerade, +
          EigenAus = TS[ind][FremdEin].plus;
          break;

        default:     // unbefahrbar bzw. gesperrt
          Serial.println(F("unbefahrbar "));
          GL_unbefahrbar = true;
          EigenAus = 0;
          break;
      } // switch
      } // if
      else {                   // DKW mit zwei Antrieben          
          switch (GL_DKWcdState) {
          case 5: // 
                EigenAus = TK[ind][FremdEin].pabpcd;                
                break;
          case 9:
                EigenAus = TK[ind][FremdEin].pabmcd;                
                break;
          case 6:
                EigenAus = TK[ind][FremdEin].mabpcd;                
                break;
          case 10:
                EigenAus = TK[ind][FremdEin].mabmcd;                
                break;                
          default:
                Serial.println(F("unbefahrbar "));
                GL_unbefahrbar = true;
                EigenAus = 0;
                break;
          } // switch
      } // else
      break;

    case 24:  // Doppelweichen
    case 25:
      switch (Ele & AufAb) {   // EigenAus 0 wenn in Fstr.
        case 0x40:    // oben,  01-> Lage 1
          EigenAus = TD[ind][FremdEin].oben;
          break;
        case 0x80:    // mitte, 10-> Lage 2
          EigenAus = TD[ind][FremdEin].mitte;
          break;
        case 0xC0:    // unten, 11-> Lage 3
          EigenAus = TD[ind][FremdEin].unten;
          break;
        default:
          Serial.println(F("unbefahrbar "));
          GL_unbefahrbar = true;
          EigenAus = 0;
          break;
      } // switch Lage DW

    default:      // keine Weiche
      Serial.println(__LINE__);
      break;
  } // switch Ele

  return (EigenAus);
} // EigenOut()

#ifdef LOCONET
// Some turnout decoders (DS54?) can use solenoids, this code emulates the digitrax
// throttles in toggling the "power" bit to cause a pulse
void requestSwitch(int address, byte dir, byte wdelay) {
  LocoNet.requestSwitch(address, 1, dir);
#ifdef STANZLN
  LnPacket = LocoNet.receive();
  if (LnPacket) LocoNet.processSwitchSensorMessage(LnPacket);
#endif
  if (!wdelay) LocoNet.requestSwitch(address, 0, dir);
}

// This call-back function is called from LocoNet.processSwitchSensorMessage
// for all Switch Request messages
void notifySwitchRequest(uint16_t Address, uint8_t Output, uint8_t Direction) {
#ifndef STANZLN
  if (!StaLN) return;
#endif
  if (!Output) return;
  bool     Address2 = false; //Zweitadresse vorhanden
  bool     Diagonal = false; //einfache Weiche diagonal
  byte     Ecke     = 0;
  byte     Element  = 0;
  uint8_t  SwSwap   = 0;
  uint16_t StpAddr;
  int x; int y;

  for (y = 0; y < YDIM; y++) {
    for (x = 0; x < XDIM; x++) {
      StpAddr = StpA[y][x] & ADRMASK;
      if (Address == StpAddr) goto Display;
      Address2 = StpA[y][x] & ADRZWEI;
      if ((Address2) && (Address == StpAddr + 1)) goto Display;
    }
  }
  return;

Display:
  Element = StpM[y][x] & 0x1F;
  if ((Element != 0) && (Element <= 7)) Element = StpS[y][x] & 0x1F;
  else                                  SwSwap = (StpA[y][x] >> ADRsSHT) & 0x01;

  switch (Element) {
    case  0:
      if (Direction) DrawKey(x, y, 1, GREEN, "EIN");
      else           DrawKey(x, y, 0, RED, "aus");
      break;

    case  8:
    case  9:
    case 10:
    case 11: Diagonal = true;

    case 16:
    case 17:
    case 18:
    case 19:
      if (SwSwap) {
        if (Direction) Direction = 0;
        else           Direction = 1;
      }
      if (Direction) {
        if (Diagonal) DrawDiagonalStand(x, y, 2);
        else          DrawSwitchStand(x, y, 1);
      }
      else {
        if (Diagonal) DrawDiagonalStand(x, y, 1);
        else          DrawSwitchStand(x, y, 2);
      }
      break;

    case 12:
    case 13:
      if (SwSwap) {
        if (Direction) Direction = 0;
        else           Direction = 1;
      }
      if (StpA[y][x] & ADR1DKW) {
        if (StpM[y][x] & 0x3F) Init1ADKW(x, y);
        if (Direction) CircleF(x, y, 4, BLACK);
        else           CircleF(x, y, 4, WHITE);
        break;
      }
      if (StpM[y][x] & 0x3F) {
        TurnoutDir(x, y, 0, WHITE);
        TurnoutDir(x, y, 2, WHITE);
      }
      if (!Address2) Ecke = 2;
      if (Direction) {
        TurnoutPos(x, y, Ecke + (Element & 0x01), DGRAY);
        TurnoutDir(x, y, Ecke, WHITE);
      }
      else {
        TurnoutDir(x, y, Ecke, DGRAY);
        TurnoutPos(x, y, Ecke + (Element & 0x01), WHITE);
      }
      break;

    case 24: Ecke = 2;
    case 25:
      if (Direction) {
        TurnoutPos(x, y, Ecke, DGRAY);
        TurnoutPos(x, y, Ecke + 1, DGRAY);
        TurnoutDir(x, y, Ecke,  WHITE);
        break;
      }
      if (Address2) {
        TurnoutPos(x, y, Ecke, DGRAY);
        TurnoutDir(x, y, Ecke, DGRAY);
        TurnoutPos(x, y, Ecke + 1, WHITE);
      }
      else {
        TurnoutPos(x, y, Ecke + 1, DGRAY);
        TurnoutDir(x, y, Ecke, DGRAY);
        TurnoutPos(x, y, Ecke, WHITE);
      }
      break;

    case 26:
    case 27:
      if (Direction) {
        if (Address2) {
          CircleSig(x, y, Element & 0x03, RED);
          ShHPicture(x, y, Element & 0x03, 1);
        }
        else {
          ShHPicture(x, y, Element & 0x03, 0);
          CircleSig(x, y, Element & 0x03, LGREEN);
        }
      }
      else {
        CircleSig(x, y, Element & 0x03, RED);
        ShHPicture(x, y, Element & 0x03, 0);
      }
      break;

    case 28:
    case 29:
      if (Direction) CircleSig(x, y, Element & 0x03, LGREEN);
      else           CircleSig(x, y, Element & 0x03, RED);
      break;

    case 30:
    case 31:
      if (Direction) ShPicture(x, y, Element & 0x03, 1);
      else           ShPicture(x, y, Element & 0x03, 0);

    default:
      break;
  }
}

// This call-back function is called from LocoNet.processSwitchSensorMessage
// for all Sensor messages
void notifySensor(uint16_t Address, uint8_t State) {
  if (!RMlnt) return;
  uint16_t RMadr = Address - RMoff1;
  if ((RMadr != 0) && (RMadr <= 8)) {
    digitalWrite(RMpin[RMadr - 1], !State);
    return;
  }
  RMadr = Address - RMoff2;
  if ((RMadr != 0) && (RMadr <= 8)) digitalWrite(RMpin[RMadr + 7], !State);
}

// This call-back function is called from LocoNet.processSwitchSensorMessage
// for all Centralstation messages
void notifyPower(uint8_t State) {
  switch (State) {
    case 0:
    case OPC_GPOFF: MelderUpdate(indicTPwr, RED);
      break;
    case 1:
    case OPC_GPON: MelderUpdate(indicTPwr, LGREEN);
      break;
    case OPC_IDLE: MelderUpdate(indicBusy, BLUE);
      break;
    case OPC_BUSY: MelderUpdate(indicBusy, RED);
      break;
    default:
      break;
  }
}

// This call-back function is called from LocoNet.processSwitchSensorMessage
// for OPC_MULTI_SENSE 0xD0
void notifyMultiSenseTransponder(uint16_t Address, uint8_t Zone, uint16_t LocoAddress, uint8_t Present) {
//  Serial.print("Railcom Sensor ");
//  Serial.print(Address);
//  Serial.print(" reports ");
//  Serial.print(Present ? "present" : "absent");
//  Serial.print(" of decoder address ");
//  Serial.print(LocoAddress, DEC);
//  Serial.print(" in zone ");
//  Serial.println(Zone, HEX);
  if (!RMlnt) return;
  Address--;
  if (!Present) LocoAddress = 0x7777;
  uint16_t RMadr = Address - RMoff1;
  if ((RMadr != 0) && (RMadr <= 8)) {
    RCtrNumber(RMadr, LocoAddress);
    return;
  }
  RMadr = Address - RMoff2;
  if ((RMadr != 0) && (RMadr <= 16)) RCtrNumber(RMadr + 8, LocoAddress);
}
#endif
//------------------------------------------------------------------------

void setup()   {

  pinMode(ledpin, OUTPUT);

  pinMode(RESETLINE, OUTPUT);  // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(RESETLINE, 1);  // Reset the Display via D4
  delay(100);
  digitalWrite(RESETLINE, 0);  // unReset the Display via D4
  delay(2500);                 // 5000 do not change

  // 16 Bit Rueckmelder
  DDRA  = 0x00;  // 8 Input    pin22=PA0, ..., pin29 PA7, pin25=PA3, (0x08)
  PORTA = 0xFF;  // 8x Pull-up
  DDRC  = 0x00;  // 8 Input    pin37=PC0, ..., pin30=PC7
  PORTC = 0xFF;  // 8x Pull-up

#ifndef LOCONET
  Serial.begin(9600);      // Debug Info
#else
  char BaudRate[] = {0x00, 0x26, 0x00, BaudIndex}; //initial 9600 für Display
  Serial.begin(BaudRate0); // Debug Info
#endif

  Serial.print(str + fslen - 14); Serial.print(' ');      // Dateiname
  Serial.print(datum); Serial.print(' '); Serial.println(__TIME__);

  csvStart(); // Check, ob EEPROM ok, sonst vordefiniert
  Serial.print(F("wait Display ... "));

  Serial2.begin(9600);     // Display-Komunikation
#ifdef LOCONET
  Serial2.write(BaudRate, 4); delay(100);
  Serial2.begin(BaudRate2);
#endif

  Serial2.write (BackGround, 4); delayS2(); // zuerst, sonst unwirksam, Text hat eigenen Background
  Serial2.write (ClearScreen, 2); delayS2();

  Serial.println(F("ok."));

  Serial2.write (0x00);       Serial2.write (0x18); Serial2.write(' ');
  Serial2.write (datum, dlen); Serial2.write (0); delayS2();

  Serial2.write (0x00);     Serial2.write (0x18); Serial2.write(' ');
  Serial2.write (__TIME__, strlen(__TIME__)); Serial2.write(' '); Serial2.write (0); delayS2();

  Serial2.write (0x00);     Serial2.write (0x18);
  Serial2.write (str + fslen - 22, 22); Serial2.write (0); delayS2();

  strcpy(stri, str + fslen - 7); // zB. s61.ino

  csvNew();  // ggf. neue csv-Datei via Terminal

  Serial2.write (BackGround, 4); delayS2(); // Loeschen Datum, Version
  Serial2.write (ClearScreen, 2); delayS2();

  buf = Serial2.read ();

  Timer1.initialize(10000);   // 5000 mikros = 5 ms, 10000 mikros = 10 ms
  Timer1.attachInterrupt(ISR_timer1);

  startzeitC = currentT1();
  startzeitB = currentT1();
  startzeitA = currentT1();
  //------------------------------------------------------------------------

  if (EEPcheck()) { //
    // EEProm check Failed, predefined XBusAdr.
  }
  else { // EEPROM ok
#ifndef LOCONET
    GL_XBusAdr = EEPROM.read(XAHDSTRPV);
#else
#ifndef STANZLN
    StaLN = EEPROM.read(SALoconet);
#endif
    EEPROM.get(RMOffset1, RMoff1); EEPROM.get(RMOffset2, RMoff2); RMsts = EEPROM.read(RMStStat); RMlnt = EEPROM.read(RMLoconet);
#endif
  }
  //------------------------------------------------------------------------
#ifndef LOCONET
  XpressNet.start(GL_XBusAdr, XNetSRPin);    //Initialisierung XNet-Bus
  Serial.print(F("X-Bus Adress: ")); Serial.println(GL_XBusAdr);
  XpressNet.setPower(csNormal); // beim Start schaedlich (MM-Zentrale)?
#else
  Serial.println();
#ifndef STANZLN
  Serial.print(F("Stellungsanzeige ueber Loconet: ")); if (!StaLN) Serial.print(F("de")); Serial.println(F("aktiviert"));
#endif
  Serial.print(F("Rueckmelder ueber Loconet:      ")); if (!RMlnt) Serial.print(F("de")); Serial.println(F("aktiviert"));
  if (RMlnt) {
    Serial.print(F("Rueckmelder: ")); Serial.print(F("Offset1 ")); Serial.print(RMoff1);
    Serial.print(F(", Offset2 ")); Serial.print(RMoff2);
    Serial.print(F(", Startstatus ")); if (RMsts) Serial.println(F("frei")); else Serial.println(F("belegt"));
  }

  // 16 Bit Rueckmelder LocoNet
  if (RMlnt) {
    DDRA  = 0xFF; // 8 Output    pin22=PA0, ..., pin29 PA7, pin25=PA3, (0x08)
    PORTA = RMsts;
    DDRC  = 0xFF; // 8 Output    pin37=PC0, ..., pin30=PC7
    PORTC = RMsts;
  }

  Serial.println();
  LocoNet.init (LN_TX_PIN);
  Serial.println (F("LocoNet initialisiert"));
  Serial.println();
#endif

  //------------------------------------------------------------------------
  GL_DebOpt = EEPROM.read(DEBUGOPT);
  Serial.print(F("Debug-Option: ")); Serial.println(GL_DebOpt);
  //------------------------------------------------------------------------

  //while (Serial.available() <= 0) { };
  //#ifndef LOCONET
  uart3init();
  //#endif
} // setup()


//----------------- isr ------------------------------------
void ISR_timer1() {
  extern volatile unsigned long int tickerT1;
  static int icnt = 0;
  static byte LEDMstate = 1;

  tickerT1++;
  icnt++;
  //digitalWrite(ledpin, LOW);
} // isr
//----------------------------------------------------------


unsigned long int currentT1(void) {
  return tickerT1;
}


boolean zeitabgelaufen (unsigned long int startzeit, unsigned long int wartezeit) {
  return (currentT1() - startzeit >= wartezeit);
}


void LifeLamp (void) {
  static unsigned long int cnt = 0;
  digitalWrite(ledpin, HIGH);
} // LifeLamp()


bool WSearch(uint16_t Wnum) {       // Suche, wenn Aufruf aus Fstr.
  bool Erfolg = false;

  for (int k = 0; (k < AnzWeichen); k++) { // (k < AnzWeichen) || Erfolg; nok

    if (Wnum == (Weiche[k].Eladress) & ADRMASK) {
      GL_Wx =   Weiche[k].Elxkoord;
      GL_Wy =   Weiche[k].Elykoord;
      Erfolg = true;
      break; // beendet Suchschleife
    }
  } // for
  return Erfolg;
} // WSearch()


void FwegListe(void) {                          // periodischer Aufruf, Fahrwegauftrag abarbeiten
  // je Aufruf eine Weiche
  static  int i = 0; // Schrittweise i++
  bool     Diagonal = false;
  byte     Fwnum    = GLOB_FwegAuftrag;
  uint8_t  HAdr     = 0;
  uint8_t  LAdr     = 0;
  uint8_t  Throw    = 0; // Stellkommando
  uint8_t  Swap     = 0;
  byte     Lageist  = 0;
  byte     LageEle  = 0;
  byte     Lagesoll = 0;

  static uint8_t DWele    = 0;
  static uint8_t DWeins   = 0;                // Antrieb 1 Schaltwert
  uint8_t        DWzwei   = 0;                // Antrieb 2 Schaltwert
  uint8_t        Swap2_1  = 0;
  uint8_t        Swap1    = 0;
  static uint8_t Swap2    = 0;

  if (Fwnum == 0xFF) Fwnum = 0;                 // erlaubt Zugriff auf Fweg[0][i]

  //Serial.print("i: ");Serial.println(i);
  int16_t  Wnum = Fweg[Fwnum][i];               // Wnum aus [] ist mit VZ

// -------------------------------------------------------
  if (WSearch(abs(Wnum))) {                     // suche nach Weiche |Wnum|
    // 2. Adresse DW wird nicht gefunden !!!!!
    byte   Element = StpM[GL_Wy][GL_Wx];
    Lageist  = Element >> 6;
    Lagesoll = 1; if (Wnum < 0) Lagesoll = 2; // Vorzeichen ist Lage!
    //Serial.print("Wnum: ");Serial.println(Wnum);

    if (Element & FSTRBEL) { // kein Fahrweg ueber Fstr.
      i = 0;
      GLOB_FwegAuftrag = 0; // Ende eines Fahrweges
      return;
      }
      
    DWele = Element & 0x3F;       // fuer 2.Lage, mit Fstr.bit
    switch (Element & 0x1F) {
      case 24:                        // DW 1. Adresse
      case 25:
        {
        Wnum = abs(Wnum);
        Swap2_1 = GetSwapDW(GL_Wx, GL_Wy);
        Swap1   = Swap2_1 & 0x01;
        Swap2   = Swap2_1 >> 1;
       
#ifndef LOCONET
        Wnum--;
        Throw = 0b1001;
        if (Lagesoll == 1) Throw = 0b1000;
        DWeins = Throw & 0x01;
        ShowEraseLageDW(GL_Wx, GL_Wy, DGRAY);
        
        Throw = 0x08 | (Swap1 ^ (0x01 & Throw));
        XpressNet.setTrntPos(highByte(Wnum), lowByte(Wnum), Throw);
        Debug32(highByte(Wnum), lowByte(Wnum), Throw);
#else
        Throw = RND_ROT;
        if (Lagesoll == 1) Throw = GRD_GRN;
        DWeins = Throw & 0x01;
#ifndef STANZLN
        ShowEraseLageDW(GL_Wx, GL_Wy, DGRAY);
#endif
        if (Throw == RND_ROT) requestSwitch(Wnum + 1, GRD_GRN, 0); // Fuer symmetrische Doppelweiche (Dreiwegweiche)
        requestSwitch(Wnum, Throw, 0);
        Debug32(Wnum, Throw);
#endif
        break; // case 24, 25
        }
        
      case 12:                        // DKW
      case 13:
             {              
             if (Lageist == 0) {
                if (StpA[GL_Wy][GL_Wx] & ADR1DKW) Init1ADKW(GL_Wx, GL_Wy); // DKW mit einem Antrieb
                else {
                   InitDKWabcd(GL_Wx, GL_Wy);                       // DKW mit zwei Antrieben
                   Lageist = 1;                    
                   }
             }
             //Serial.print("Adr, a/b Lage ist, soll: "); Serial.print((StpA[GL_Wy][GL_Wx]) & 0xFF);Serial.print(',');
             //Serial.print(Lageist); Serial.print(',');Serial.println(Lagesoll);
             
             if (Lageist != Lagesoll) CmpSetDKW(GL_Wx, GL_Wy, DKWab, Lagesoll); 
             break;
             }
             
      case  8:
      case  9:
      case 10:
      case 11: Diagonal = true;

      case 16:
      case 17:
      case 18:
      case 19:
        {
        Wnum = abs(Wnum);
        
#ifndef LOCONET
        Wnum--;  // Versatz lt. XBus Lenz/Roco ist 1 als Adresse 0 auf dem XBus
        HAdr = highByte(Wnum);  LAdr = lowByte(Wnum);
#endif
        Swap = (StpA[GL_Wy][GL_Wx] >> ADRsSHT) & 0x01;

        if (Lageist != Lagesoll) { // Stelle Weiche
          switch (Lagesoll) {
            case 2: 
              {
              Element = Element & 0b00111111;
              Element = Element | 0b10000000;
              StpM[GL_Wy][GL_Wx] = Element;

#ifndef LOCONET
              if (Swap) Throw = 0b1001;
              else      Throw = 0b1000;   // normal 0b1000, Bogen
              XpressNet.setTrntPos(highByte(Wnum), lowByte(Wnum), Throw);
              Debug32(highByte(Wnum), lowByte(Wnum), Throw);
              //WR2Queue(HAdr, LAdr, 0b1000,0);                // nicht verwenden wg. Display/Schaltsync.
#else
              if (Swap) Throw = GRD_GRN;
              else      Throw = RND_ROT;   // normal 0b1000, Bogen
              requestSwitch(Wnum, Throw, 0);
              Debug32(Wnum, Throw);
#endif
#ifndef STANZLN
              if (Diagonal) DrawDiagonalStand(GL_Wx, GL_Wy, 1);
              else          DrawSwitchStand(GL_Wx, GL_Wy, 2);
#endif
              break; // case 2, switch(Lagesoll)
              }
              
            case 1: 
              {
              Element = Element & 0b00111111;
              Element = Element | 0b01000000;
              StpM[GL_Wy][GL_Wx] = Element;

#ifndef LOCONET
              if (Swap) Throw = 0b1000;
              else      Throw = 0b1001;   // normal 0b1001, gerade
              XpressNet.setTrntPos(highByte(Wnum), lowByte(Wnum), Throw);
              Debug32(highByte(Wnum), lowByte(Wnum), Throw);
              //WR2Queue(HAdr, LAdr, 0b1001,0);
#else
              if (Swap) Throw = RND_ROT;
              else      Throw = GRD_GRN;   // normal 0b1001, gerade
              requestSwitch(Wnum, Throw, 0);
              Debug32(Wnum, Throw);
#endif
#ifndef STANZLN
              if (Diagonal) DrawDiagonalStand(GL_Wx, GL_Wy, 2);
              else          DrawSwitchStand(GL_Wx, GL_Wy, 1);
#endif
              break; // case 1, switch(Lagesoll)
              }
            default:
              break; //  
          } // switch Lagesoll
          
        } // if Lageist
       break; // case einfache Weichen
      }
      
      default:
        break;
    } // switch Element
    
    i++;    
    if (Fweg[Fwnum][i] == 0) {
        GLOB_FwegAuftrag = 0; // Ende eines Fahrweges
        //ProcDauertest();    // ggf. Folgeauftrag
        i = 0;
    } // if Fweg Ende
    
  } // if WSearch
  
// -------------------------------------------------------
  else {               // Weiche nicht gefunden, Test ob DW oder DKW
    if (DWele & FSTRBEL) return;           // kein Fahrweg ueber Fstr.
        
    if ((DWele == 12) || DWele == 13) {
       if (StpA[GL_Wy][GL_Wx] & ADR1DKW) {}           // ein Antrieb
       else {                                         // zwei Antriebe               
               Lagesoll = 1; if (Wnum < 0) Lagesoll = 2; // Vorzeichen ist Lage!
               //Serial.print("c/d Lage ist, soll: "); 
               //Serial.print(GetLageDKWcd(GL_Wx, GL_Wy)); Serial.print(',');Serial.println(Lagesoll);
               if (GetLageDKWcd(GL_Wx, GL_Wy) != Lagesoll) CmpSetDKW(GL_Wx, GL_Wy, DKWcd, Lagesoll);                
               DWele = 0; 
        }      
    }

    if ((DWele == 24) || DWele == 25) {
#ifndef LOCONET
      Throw = 0b1000;
      if (Wnum < 0) Throw = 0b1001;      // Wnum ist 2. Adresse der DW
#else
      Throw = GRD_GRN;
      if (Wnum < 0) Throw = RND_ROT;     // Wnum ist 2. Adresse der DW
#endif
      DWzwei = Throw & 0x01;
      Lageist = DWeins + (DWzwei << 1);
      if (DWele == 24) {
        switch (Lageist) {
#ifndef LOCONET
          case 0: LageEle = 2; break;
          case 1: LageEle = 1; break;
          case 2: LageEle = 3; break;
#else
          case 3:
          case 0: LageEle = 2; break;
          case 1: LageEle = 3; break;
          case 2: LageEle = 1; break;
#endif
          default: break;
        }
      }
      else {     // DWele == 25
        switch (Lageist) {
#ifndef LOCONET
          case 0: LageEle = 2; break;
          case 1: LageEle = 3; break;
          case 2: LageEle = 1; break;
#else
          case 3:
          case 0: LageEle = 2; break;
          case 1: LageEle = 1; break;
          case 2: LageEle = 3; break;
#endif
          default: break;
        }
      }

      Wnum = abs(Wnum);
      StpM[GL_Wy][GL_Wx] = DWele | (LageEle << 6);
#ifndef LOCONET
      Wnum--;
      ShowEraseLageDW(GL_Wx, GL_Wy, WHITE);

      Throw = 0x08 | (Swap2 ^ (0x01 & Throw));
      XpressNet.setTrntPos(highByte(Wnum), lowByte(Wnum), Throw);
      Debug32(highByte(Wnum), lowByte(Wnum), Throw);
#else
#ifndef STANZLN
      ShowEraseLageDW(GL_Wx, GL_Wy, WHITE);
#endif
      if (Lageist != 2) requestSwitch(Wnum, Throw, 0); // Fuer symmetrische Doppelweiche (Dreiwegweiche) wurde schon gerade gestellt
      Debug32(Wnum, Throw);
#endif
      DWele = 0;

      }  // if Dwele 24, 25 
      else DWele = 0;   // nicht 24 oder 25
      
      i++;
      if (Fweg[Fwnum][i] == 0) {
          GLOB_FwegAuftrag = 0; // Ende eines Fahrweges
          //ProcDauertest();    // ggf. Folgeauftrag
          i = 0;
          }
   
  } // else Weiche nicht gefunden, DW oder DKW moeglich
  
} //FwegListe()



void newCheckSignal(int fx, int fy) { // Aufruf wenn Touch auf Element <= 3

#define GERADE_GN 0b1001
#define RUND_ROT  0b1000

  uint8_t   Element  = StpS[fy][fx];
  uint16_t  Adr      = 0;
  uint8_t   HAdr     = 0;
  uint8_t   LAdr     = 0;
  uint8_t   Schalt   = RUND_ROT;
  uint16_t  colour   = RED;
  uint8_t   Lage     = 0;
  uint8_t   Signal   = 0;
  bool      ok       = false;
  bool      FstrCh   = false;
  uint8_t   Gleis    = 0;

  if (Element & 0x20) return; // kein Fstr.Start bei Sig. invisible

  Signal = Element & 0x1F;

  switch (Signal) {
    case 26:
    case 27:
    case 28:
    case 29:
    case 30:
    case 31:
      switch (GL_RouteClass) {
        case 0: { // Testmodus, Weichen, Fahrwege und Signale frei bedienbar
            // keine Fahrstrassen, Signale. Playmode 0

            if (GL_Bediensperre) return;

            if ((StpS[fy][fx]) & 0x80) SignalHp1(fx, fy);
            else                       SignalHp0(fx, fy);

            GL_Bediensperre = 1;
            startzeitD = currentT1();

            break;
          }
        case 1:
        case 2:
        case 3:
        case 4: {

            Gleis = StpM[fy][fx];
            Serial.print(__LINE__); Serial.print(' '); Tracker(fx, fy, Gleis);

            if (Gleis & FSTRSTART) {   // if Fstr. exist, -> Fstr. Abbau
              // Fstr. Abbau  -------------------------------------------------------

              SignalHp0(fx, fy);
              Verfolger(fx, fy); // dort nochmals Pruefung Aufbau/Abbbau
            }
            else { // nicht belegt durch Fstr.
              // Fstr. Aufbau -------------------------------------------------------
              // vor Aufbau Pruefung der Fstr.

              FstrCh = FstrPruefer(fx, fy); // Pruefen, Ziel: Beim Treffen auf belegtes Ele. keine Fstr.
              if (FstrCh)  {
                // Pruefung erfolgreich -----------------------------------------------
                Serial.println(); Serial.println(); Serial.println(F(" -> Fstr. Aufbau:"));
                Verfolger(fx, fy); // Fstr.Aufbau
                //FWegDump();     // @ debug
                // Signalfahrt
                Lage = Element >> 6;

                uint8_t Signal = Element & 0x1F;
                switch (Lage) {
                  case 0: Element = Element | 0b01000000;
                    StpS[fy][fx] = Element;
                    SignalHp1(fx, fy);
                    break;
                  case 1: Element = Element & 0b00111111;
                    Element = Element | 0b10000000;
                    StpS[fy][fx] = Element;
                    SignalHp0(fx, fy);
                    break;
                  case 2: Element = Element & 0b00111111;
                    Element = Element | 0b01000000;
                    StpS[fy][fx] = Element;
                    SignalHp1(fx, fy);
                    break;
                  default:
                    break;
                } // switch Lage
              } // if FstrCh ok

              else {
                Serial.println (F("Ablehnung Pruefer"));
              }
            } //  nicht belegt durch Fstr. -> Aufbau moeglich

          } // RouteClass 1 bis 4
        default:
          break;
      } // switch(GL_RouteClass)

  } // switch(Signal)

} // newCheckSignal()


void SignalMode0(uint8_t fx, uint8_t fy) {

  if ((StpS[fy][fx]) & 0x80) SignalHp1(fx, fy);
  else                       SignalHp0(fx, fy);
}


void SignalHp0(uint8_t fx, uint8_t fy) {

  uint8_t   Element  = StpS[fy][fx];
  uint16_t  Adr      = 0;
  uint8_t   HAdr     = 0;
  uint8_t   LAdr     = 0;
  bool      ok       = false;
  uint8_t   Signal   = 0;

  Signal = Element & 0x1F;
  switch (Signal) {
    case 26:
    case 27:
    case 28:
    case 29:
    case 30:
    case 31: Adr = StpA[fy][fx];
      if (Adr) {
#ifndef LOCONET
        Adr--;    // Versatz !!!!!!!!!!!!!!!
        HAdr = highByte(Adr);  LAdr = lowByte(Adr);
#endif
        ok = true;
      }
      else ok = false;

      Element = Element & 0b00111111;
      Element = Element | 0b10000000;
      StpS[fy][fx] = Element;

      if (ok) {        
        switch (Signal) {
          case 26:
          case 27:
#ifndef LOCONET
            Adr++;                                             // zweite Adresse, Sonderregel HS-Signal
            WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);  // Sh0
            //WR2Queue(highByte(Adr), lowByte(Adr), 0b1000,0); // Sh0 // Sh1 bleibt mitunter
            if (!GL_SigZR) WR2Queue(HAdr, LAdr, 0b1000, 0);    // Hp0, rot
#else
            requestSwitch(Adr + 1, RND_ROT, 0);                // Sh0
            //if (!GL_SigZR) requestSwitch(Adr, RND_ROT, 0);   // Hp0, rot
            requestSwitch(Adr, RND_ROT, 0);                    // Hp0, rot
#endif
            break;
          case 28:
          case 29:
          case 30:
          case 31:
#ifndef LOCONET
            WR2Queue(HAdr, LAdr, 0b1000, 0);  // Hp0 od. Sh0
#else
            requestSwitch(Adr, RND_ROT, 0);
#endif
            break;

          default: break;
        }
      }
#ifndef STANZLN
      switch (Signal) {
        case 26:
        case 27: CircleSig ( fx,  fy, Element & 0x03,  RED);
          ShHPicture( fx,  fy, Element & 0x03, 0);
          break;
        case 28:
        case 29: if ((StpS[fy][fx] & 0x20) == 0)      // invisible
            CircleSig ( fx,  fy, Element & 0x03,  RED);
          break;
        case 30:
        case 31: ShPicture ( fx,  fy, Element & 0x03, 0);
          break;
        default:
          break;
      }
#endif
    default:
      break;
  } // switch(Signal)

} // SignalHp0()


void SignalHp1 (uint8_t fx, uint8_t fy) {

  uint8_t   Element  = StpS[fy][fx];
  uint16_t  Adr      = 0;
  uint8_t   HAdr     = 0;
  uint8_t   LAdr     = 0;
  bool      ok       = false;
  uint8_t   Signal   = 0;

  Signal = Element & 0x1F;
  switch (Signal) {
    case 26:
    case 27:
    case 28:
    case 29:
    case 30:
    case 31: Adr = StpA[fy][fx];
      if (Adr) {
#ifndef LOCONET
        Adr--;       // Versatz !!!!!!!!!!!!!!!
        HAdr = highByte(Adr);  LAdr = lowByte(Adr);
#endif
        ok = true;   // Adresse existiert
      }
      else ok = false; // ohne Adresse

      Element = Element & 0b00111111;
      Element = Element | 0b01000000;
      StpS[fy][fx] = Element;

      if (ok) {
        switch (Signal) {
          case 26:
          case 27:
#ifndef LOCONET
            if (!GL_SigZR) WR2Queue(HAdr, LAdr, 0b1001, 0); // Hp1, gruen
            //WR2Queue(HAdr, LAdr, 0b1001,0);   //
            Adr++;                                          // zweite Adresse, Sonderregel HS-Signal
            HAdr = highByte(Adr);  LAdr = lowByte(Adr);
            WR2Queue(HAdr, LAdr, 0b1001, 0);                //Sh1
#else
            if (!GL_SigZR) requestSwitch(Adr, GRD_GRN, 0);     // Hp1, gruen
            else           requestSwitch(Adr + 1, GRD_GRN, 0); // Sh1
            //requestSwitch(Adr + 1, GRD_GRN, 0);              // Sh1
#endif
            break;
          case 28:
          case 29:
          case 30:
          case 31:
#ifndef LOCONET
            WR2Queue(HAdr, LAdr, 0b1001, 0);                // Hp1 oder Sh1, gruen
#else
            requestSwitch(Adr, GRD_GRN, 0);                 // Hp1 oder Sh1, gruen
#endif
            break;

          default: break;
        }
      }
#ifndef STANZLN
      switch (Signal) {
        case 26:
        case 27:
#ifndef LOCONET
          ShHPicture ( fx,  fy, Element & 0x03, 1);
          if (!GL_SigZR) CircleSig ( fx,  fy, Element & 0x03,  LGREEN);
#else
          if (!GL_SigZR) CircleSig ( fx,  fy, Element & 0x03,  LGREEN);
          else           ShHPicture ( fx,  fy, Element & 0x03, 1);
#endif
          break;
        case 28:
        case 29: if ((StpS[fy][fx] & 0x20) == 0)      // invisible
            CircleSig ( fx,  fy, Element & 0x03,  LGREEN);
          break;
        case 30:
        case 31: ShPicture ( fx,  fy, Element & 0x03, 1);
          break;
        default:
          break;
      }
#endif
    default:
      break;
  } // switch(Signal)

} // SignalHp1()


void FstrDraw(int x, int y, byte Element, int KommtVon, int colour) {
  //extern uint8_t GL_KreuzungInfo;

  switch (Element & 0x1F) {
    case  1:
    case  2:
    case  3: if (!(Element & DETECTSET)) TrackLight(x, y, colour);
      break;
    case  4:                        // Ecke
    case  5:
    case  6:
    case  7: PosLight  (x, y, colour);
      break;
    case  8:                       // Weichen /-
    case  9:
    case 10:
    case 11: DrawSwDiaFstr(x, y, colour);
      break;
    case 12:                       // DKW ein Antrieb
    case 13: DrawDKWFstr(x, y, colour, KommtVon); 
      break;
    case 16:                       // Weichen _/_
    case 17:
    case 18:
    case 19: DrawSwFstr(x, y, colour);
      break;

    case 24:                       // Doppelweichen
    case 25: if (colour == DGRAY) ShowEraseLageDW(x, y, WHITE);
             else                 ShowEraseLageDW(x, y, colour);
      break;

    case 15: if ((KommtVon == 1) || (KommtVon == 4)) TurnoutLong(x, y, 0, colour);
             else TurnoutLong(x, y, 3, colour);
      break;

    case 20:                       // Diagonale
    case 21: TurnoutLong(x, y, Element & 0x03, colour);
      break;
    // Kreuzung
    case 22:   if ((KommtVon == 2) || (KommtVon == 5)) KreuzWaager(x, y, colour);
               else {
                    TurnoutPos(x, y, 0, colour);
                    TurnoutPos(x, y, 2, colour);
               }
      break;

    case 23:   if ((KommtVon == 2) || (KommtVon == 5)) KreuzWaager(x, y, colour);
               else {
                    TurnoutPos(x, y, 1, colour);
                    TurnoutPos(x, y, 3, colour);
                    }
      break;

    default:
      break;

  } // switch ()

} // FstrDraw()



void DrawDKWFstr(int fx, int fy, uint16_t colour, uint16_t KommtVon) {

  // 01xx xxxx Lage gerade (grün)
  // 10xx xxxx Lage rund, bogen, rot

  int Element = StpM[fy][fx];
  int col = YELLOW;
  if (colour == DGRAY) col = WHITE;

  if (StpA[fy][fx] & ADR1DKW) { // if DKW ein Antrieb
      DrawDKW1AabFstr(fx, fy, col, KommtVon);
      }  
  else { // DKW mit 2 Antrieben
       uint8_t Lage_abcd = GetLageDKWabcd(fx, fy);
       // cdab
       // 0101  5 ++
       // 0110  6 +-
       // 1001  9 -+
       // 1010 10 --       
       DrawDKWcdFstr(fx, fy, col, KommtVon, Lage_abcd);     
  } // DKW zwei Antriebe
} // DrawDKWFstr()



void DrawDKWcdFstr(int fx, int fy, uint16_t col, uint16_t KommtVon, uint8_t Lage_abcd) {
int Element = StpM[fy][fx];
       // cdab
       // 0101  5 ++
       // 0110  6 +-
       // 1001  9 -+
       // 1010 10 --
  switch (Element & 0x1F) {
  case 12:         
         switch (Lage_abcd) {
         case  5:
               TurnoutDir(fx, fy, 3, col);
               TurnoutDir(fx, fy, 1, col);
               break;
         case  6:
               TurnoutDir(fx, fy, 1, col); // Lage gerade 
               TurnoutPos(fx, fy, 2, col); // Lage bogen               
               break;
         case  9:
               TurnoutDir(fx, fy, 3, col); // Lage gerade 
               TurnoutPos(fx, fy, 0, col); // Lage bogen       
               break;
         case 10:
               TurnoutPos(fx, fy, 2, col); // Lage bogen
               TurnoutPos(fx, fy, 0, col); // Lage bogen
               break;
         default:
               break;
         }         
         break; // case 12
         
  case 13:         
         switch (Lage_abcd) {
         case  5:
               TurnoutDir(fx, fy, 3, col);
               TurnoutDir(fx, fy, 1, col);
               break; 
         case  6:
               TurnoutDir(fx, fy, 1, col); // Lage gerade  
               TurnoutPos(fx, fy, 3, col); // Lage bogen               
               break;
         case  9:
               TurnoutDir(fx, fy, 3, col); // Lage gerade 
               TurnoutPos(fx, fy, 1, col); // Lage bogen       
               break;      
         case 10:
               TurnoutPos(fx, fy, 1, col); // Lage bogen
               TurnoutPos(fx, fy, 3, col); // Lage bogen
               break;
         default:
               break;
         } 
         break; // case 13
        
  default:
         break;
  } // switch
} // DrawDKWcdFstr()



void DrawDKW1AabFstr(int fx, int fy, uint16_t col, uint16_t KommtVon) {
int Element = StpM[fy][fx];

switch (Element & 0x1F) {
  case 12:
       if (Element & 0x40) { // + Lage
          switch (KommtVon) {
          case 2:
          case 5: 
               TurnoutDir(fx, fy, 0, col); // Lage gerade  
               TurnoutDir(fx, fy, 3, col); // Lage gerade
               break;
          case 1:
          case 4:
               TurnoutPos(fx, fy, 0, col); // Lage bogen
               TurnoutPos(fx, fy, 2, col); // Lage bogen
               break;
          } // switch Kommtvon
       }
       if (Element & 0x80) { // - Lage
          switch (KommtVon) {
          case 2:
          case 4: 
               TurnoutPos(fx, fy, 0, col); // Lage gerade  
               TurnoutDir(fx, fy, 3, col); // Lage gerade
               break;
          case 1:
          case 5:
               TurnoutDir(fx, fy, 1, col); // Lage bogen
               TurnoutPos(fx, fy, 2, col); // Lage bogen
               break;
          } // switch Kommtvon
       }       
       break; // case 12
       
  case 13:
       if (Element & 0x40) { // + Lage
          switch (KommtVon) {
          case 2:
          case 5: 
               TurnoutDir(fx, fy, 1, col); // Lage gerade  
               TurnoutDir(fx, fy, 3, col); // Lage gerade
               break;
          case 3:
          case 6:
               TurnoutPos(fx, fy, 1, col); // Lage bogen
               TurnoutPos(fx, fy, 3, col); // Lage bogen
               break;
          } // switch Kommtvon
       }
       if (Element & 0x80) { // - Lage
          switch (KommtVon) {
          case 2:
          case 6: 
               TurnoutPos(fx, fy, 1, col); // Lage gerade  
               TurnoutDir(fx, fy, 3, col); // Lage gerade
               break;
          case 3:
          case 5:
               TurnoutDir(fx, fy, 1, col); // Lage bogen
               TurnoutPos(fx, fy, 3, col); // Lage bogen
               break;
          } // switch Kommtvon
       }
       break; // case 13
       
  default:
       break;
  } // switch Element  
  
} // DrawDKW1AabFstr()



void DrawSwFstr(int x, int y, int colour) {
  // 01xx xxxx Lage gerade (grün)
  // 10xx xxxx Lage rund, bogen, rot

  int Element = StpM[y][x];
  int col = YELLOW;
  if (colour == DGRAY) col = WHITE;

  switch (Element & 0xC0) {
    case 0x40: TurnoutDir(x, y, Element & 0x03, col); // Lage gerade
      break;
    case 0x80: TurnoutPos(x, y, Element & 0x03, col); // Lage bogen
      break;
    default:
      break;
  }
} // DrawSwFstr()


void DrawSwDiaFstr (int x, int y, int colour) {
  // 01xx xxxx Lage gerade (grün)
  // 10xx xxxx Lage rund, bogen, rot

  byte SwStand = 1;                    // gerade
  if (StpM[y][x] & 0x80) SwStand = 2;  // abzweigend, bogen

  int col = YELLOW;
  if (colour == DGRAY) col = WHITE;

  int w811 = StpM[y][x] & 0x000F; // Weiche 8,9,10,11
  byte cor1 = 0;
  byte cor2 = 0;

  switch (w811) {
    case  8: cor1 = 2; cor2 = 2; // ok
      break;
    case  9: if (SwStand == 2) {
        cor1 = 2;
        cor2 = 3;
      }
      else             {
        cor1 = 3;
        cor2 = 2;
      }
      break;
    case 10: cor1 = 0; cor2 = 0; // ok
      break;
    case 11: if (SwStand == 2) {
        cor1 = 0;
        cor2 = 1;
      }
      else             {
        cor1 = 1;
        cor2 = 0;
      }
      break;
    default:
      break;
  }

  switch (SwStand) {
    case 2: TurnoutDir(x, y, cor2, col); // Lage gerade
      break;
    case 1: TurnoutPos(x, y, cor1, col); // Lage neu bogen
      break;
    default:
      break;
  } // switch()

} // DrawSwDiaFstr()


bool SearchBField(byte xy) { // Vergleich ob touch-xy einer der touch-Felder entspricht

  bool Erfolg = false;

  for (int k = 0; (k < GL_ButtCnt); k++) {
    if (xy == ButtField[k].xyKo) {
      Erfolg = true;
      GL_ButtPos = k;
      break; // beendet Suchschleife
    }
  } // for
  return Erfolg;
}


//
// Aufruf: loop() -> TouchAction() -> KeyPressKoord()
//
void KeyPressKoord(int kx, int ky, byte flg) {  // flg: 1 make, 0 break

#define straight 0b1001
#define curved   0b1000

  static byte     first   = 1;
  byte     Element = 0;
  byte     Lage    = 0;
  uint16_t Adr     = 0;
  uint8_t  HAdr    = 0;
  uint8_t  LAdr    = 0;
  char     conv    = ' ';
  bool     Diagonal = false;
  uint8_t  Wdelay   = 0;
  uint8_t  SwSwap   = 0;

  if (first) {
    //Serial2.write(TextBackGrnd,4); delayS2();
    Serial2.write(TextColourBl, 4); delayS2();
    TextFont[3] = 5; Serial2.write(TextFont, 4); delayS2();
    first = 0;
  }
  Serial2.write(TextBackGrnd, 4); delayS2();
  Text_CR(5);

  //if (GL_TouchLock) return;

  byte fx = lowByte (kx / FELDSX); // Koordinaten Gleisbild
  byte fy = lowByte (ky / FELDSY);

  if ((fx == 0) && (fy == 0)) {
    ToggleBMsim();  // x=y=0, Simulation Belegtmelder
    Serial2.write(TextRCBackGd, 4); delayS2();
    return;         // KeyPressKoord()
  }
  Element = StpM[fy][fx];
  // ---------------------------------------------------------------------------
  if (GL_DebOpt & 0b01000000) {       // Himalaya-Patch
    AnzeigeXY (fx, fy, flg); // debug @
    Serial.print("Ele, StpA: "); Serial.print(Element); Serial.print(' '); Serial.println(StpA[fy][fx], HEX);
    i2str(1, Element);
  }

  if ((Element & 0x1F) <= 3) {   // kein Element oder Linie, ggf Signal od. Schalttaste
    AnzeigeXY (fx, fy, flg);

    // Hier Simulation Belegtmelder, Aufruf mit fx, fy
    // Belegtmeldung, wenn Element 1 oder 2 oder 3 (0 = kein Aufruf)
    // dann aber newCheckSignal() nicht aufrufen (Signal kann ja auch drauf stehen)
    // ebenso Fwegtaste, einfach Buttfield[] komplett nicht bedienen

    if (GL_BMsim && ((Element & 0x1F) > 0 )) {
      SimBelegt(fx, fy);
    }
    else {
      Ele123(fx, fy);
    }
  }  // if Element <=3
  // ---------------------------------------------------------------------------
  else              { // Element > 3
    Lage = Element >> 6;
    switch (Element & 0x1F) {
      case 24:                // Doppelweiche
      case 25:
        DrawDWstand(fx, fy, Lage);
        break;
      case 12:                // DKW
      case 13:
        DrawDKWstand(fx, fy, Lage);
        //if (StpA[fy][fx] & ADRZWEI) Serial.println("zweite DKW Adresse.");
        break;        
      case  8:
      case  9:
      case 10:
      case 11: Diagonal = true;

      case 16:
      case 17:
      case 18:
      case 19:

        if  (GL_Bediensperre) {
          Serial2.write(TextRCBackGd, 4); delayS2();
          return;
        }
        if (!(Element & FSTRBEL)) // wenn frei, umschalten
        {
          Wdelay =  StpA[fy][fx] >> ADRdSHT; // 2bit, 0..3
          SwSwap = (StpA[fy][fx] >> ADRsSHT) & 0x01;
          Adr    =  StpA[fy][fx] & ADRMASK; // 0..2047
#ifndef LOCONET
          Adr--; // Versatz !!!!!!!!!!!!!!!
          HAdr = highByte(Adr);  LAdr = lowByte(Adr);
#endif

          //XpressNet.getTrntInfo (HAdr, LAdr);    //Ermitteln Weichenstellung
          switch (Lage) {
            case 0: Element = Element | 0b01000000;
              StpM[fy][fx] = Element;
              //XpressNet.setTrntPos(highByte(Adr), lowByte(Adr), 0b1001); //switch straight
              MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"
#ifndef LOCONET
              if (SwSwap)WR2Queue(HAdr, LAdr, 0b1000, Wdelay ); // umgekehrt
              else       WR2Queue(HAdr, LAdr, 0b1001, Wdelay ); // normal
#else
              if (SwSwap) requestSwitch(Adr, RND_ROT, Wdelay);  // Schalte umgekehrt
              else        requestSwitch(Adr, GRD_GRN, Wdelay);  // Schalte normal
#endif
#ifndef STANZLN
              if (Diagonal) DrawDiagonalStand(fx, fy, 2);
              else          DrawSwitchStand(fx, fy, 1);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
              break;

            case 1: Element = Element & 0b00111111;
              Element = Element | 0b10000000;
              StpM[fy][fx] = Element;
              MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"
#ifndef LOCONET
              //XpressNet.setTrntPos(highByte(Adr), lowByte(Adr), 0b1000); //switch turn
              if (SwSwap) WR2Queue(HAdr, LAdr, 0b1001, Wdelay); // umgekehrt
              else        WR2Queue(HAdr, LAdr, 0b1000, Wdelay); // normal
#else
              if (SwSwap) requestSwitch(Adr, GRD_GRN, Wdelay);  // Schalte umgekehrt
              else        requestSwitch(Adr, RND_ROT, Wdelay);  // Schalte normal
#endif
#ifndef STANZLN
              if (Diagonal) DrawDiagonalStand(fx, fy, 1);
              else          DrawSwitchStand(fx, fy, 2);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
              break;

            case 2: Element = Element & 0b00111111;
              Element = Element | 0b01000000;
              StpM[fy][fx] = Element;
              MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"
#ifndef LOCONET
              //XpressNet.setTrntPos(highByte(Adr), lowByte(Adr), 0b1001); //switch gerade
              if (SwSwap) WR2Queue(HAdr, LAdr, 0b1000, Wdelay); // umgekehrt
              else      WR2Queue(HAdr, LAdr, 0b1001, Wdelay);   // normal
#else
              if (SwSwap) requestSwitch(Adr, RND_ROT, Wdelay);  // Schalte umgekehrt
              else        requestSwitch(Adr, GRD_GRN, Wdelay);  // Schalte normal
#endif
#ifndef STANZLN
              if (Diagonal) DrawDiagonalStand(fx, fy, 2);
              else          DrawSwitchStand(fx, fy, 1);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
              break;

            default:
              break;
          } // switch Lage
        } // if not locked
      default:
        break;
    } // switch Element

    if (GL_DebOpt) {            // Anzeige Hex Ecke unten links
        Serial2.write(TextBackGrnd, 4); delayS2();
        AnzeigeEle(flg, Element);
    }
    
  }   // else Element > 3

  // Lage in StpM[y,x] 0b00xx xxxx unbekannt
  //                   0b01xx xxxx gerade
  //                   0b10xx xxxx abzweigend
  //                   0bxx1x xxxx locked

  Serial2.write(TextRCBackGd, 4); delayS2();
} // KeyPressKoord()


void Ele123 (byte fx, byte fy) {              // die Streckenelemente 1,2,3 können Signale oder Tasten aufnehmen

  static char  Tstri[] = {"F  "};
  static byte  SwState = 1;
  int          KeyXY   = (fx << 4) + fy;
  uint16_t     Adr     = 0;
  uint8_t      HAdr    = 0;
  uint8_t      LAdr    = 0;
  byte         Lage    = 0;
  byte         Element = StpM[fy][fx];

  newCheckSignal(fx, fy);            // sonst doppelt RCL-Modus tbd !!!!

  if (SearchBField(KeyXY)) {

    switch (ButtField[GL_ButtPos].Keytype) {
      case 0: // runde Fweg-Taste
        if (GL_ButtPos) GLOB_FwegAuftrag = GL_ButtPos;
        else            GLOB_FwegAuftrag = 0xFF; // erlaubt Zugriff auf Fweg[0][i]
        //Text_CR(425);
        i2str(1, GL_ButtPos);
        num2str(GL_ButtPos, Tstri);
        if (GL_sqExist) TextPanel(GL_sqButtX, GL_sqButtY, Tstri);
        SwState = GL_ButtPos;
        break;

      case 1:  // eckige Taste FS
        //TheKeys();
        //AdrDump();
#ifndef LOCONET
        QueDump();
        //RD_Queue();
#endif
        //PointRequest();
        break;

      case 2:  // eckige Taste Fw_
        //GLOB_FwegAuftrag = SwState; // Ausfuehrung
        //Text_CR(425);
        i2str(1, SwState);
        break;

      case 3:  // eckige Taste < >
        if (SwState > GL_AnzFweg) SwState = 1;
        Fliste(SwState);
        num2str(SwState, Tstri); //
        SwState++;
        TextPanel(GL_sqButtX, GL_sqButtY, Tstri);
        break;

      case 8:  // Schalttaste mit Dig.Adr.
        if (GL_Bediensperre) return;

        Adr = StpA[fy][fx];
#ifndef LOCONET
        Adr--; // Versatz !!!!
        HAdr = highByte(Adr);  LAdr = lowByte(Adr);
#endif
        Lage = Element >> 6;
        switch (Lage) {
          case 0: Element = Element | 0b10000000;
            StpM[fy][fx] = Element;
            if (Adr) {
              Serial.print(F("Adr, val ")); Serial.print(Adr); Serial.println(F(" aus"));
#ifndef LOCONET
              //XpressNet.setTrntPos(HAdr, LAdr, 0b1000); //switch turn bogen, rot, OFF
              WR2Queue(HAdr, LAdr, 0b1000, 0);
#else
              requestSwitch(Adr, RND_ROT, 0);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
            }

#ifndef LOCONET
            DrawKey(fx, fy, 0, BLACK, "aus");
#else
#ifndef STANZLN
            DrawKey(fx, fy, 0, RED, "aus");
#endif
#endif
            GL_TouchLock = true;
            break;

          case 2: Element = Element & 0b00111111;
            Element = Element | 0b01000000;
            StpM[fy][fx] = Element;
            if (Adr) {
              Serial.print(F("Adr, val ")); Serial.print(Adr); Serial.println(F(" EIN"));
#ifndef LOCONET
              //XpressNet.setTrntPos(HAdr, LAdr, 0b1001); //switch gerade, gruen, ON
              WR2Queue(HAdr, LAdr, 0b1001, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
            }
#ifndef LOCONET
            DrawKey(fx, fy, 1, WHITE, " EIN");
#else
#ifndef STANZLN
            DrawKey(fx, fy, 1, GREEN, " EIN");
#endif
#endif
            GL_TouchLock = true;
            break;

          case 1: Element = Element & 0b00111111;
            Element = Element | 0b10000000;
            StpM[fy][fx] = Element;
            if (Adr) {
#ifndef LOCONET
              //XpressNet.setTrntPos(HAdr, LAdr, 0b1000); //switch turn bogen, rot, OFF
              Serial.print(F("Adr, val ")); Serial.print(Adr); Serial.println(F(" aus"));
              WR2Queue(HAdr, LAdr, 0b1000, 0);
#else
              requestSwitch(Adr, RND_ROT, 0);
#endif
              GL_Bediensperre = 1;
              startzeitD = currentT1();
            }
#ifndef LOCONET
            DrawKey(fx, fy, 0, BLACK, "aus");
#else
#ifndef STANZLN
            DrawKey(fx, fy, 0, RED, "aus");
#endif
#endif
            GL_TouchLock = true;
            break;

          default:
            break;
        } // switch Lage

      default:
        break;
    } // switch .keytype
  } // if SearchField

  else {  // hier Sonderfaelle Melder als Taste
    // Umschaltung RouteClass
    if (Melder[4].exist) {
      if (((Melder[4].x) << 4) + (Melder[4].y) == KeyXY)
        RouteClass(fx, fy);
    }
    // Melder[3]. soll DKW Umschaltung a/b oder c/d werden
    if (Melder[3].exist) {
      if (((Melder[3].x) << 4) + (Melder[3].y) == KeyXY)
        DKW_um(fx, fy);
    }
    // Melder[5]. Umschaltung Signale Zug- RFahrt
    if (Melder[5].exist) {
      if (((Melder[5].x) << 4) + (Melder[5].y) == KeyXY) {
        SigZR_um(fx, fy);

        if (GL_DebOpt & 0b0010) { // 2
          BMZustandDump();
        }
      } // Taste ZR
    } // Melder 5 exist

  } // else Melder als Taste

} // Ele123()


void RouteClass(uint8_t xko, uint8_t yko) {  // RouteClass temporaer aendern

  static char src[] = {"   "};

  TextPanel(xko, yko, src);            // Ausgabe leer

  GL_RouteClass++;
  if (GL_RouteClass > RCMAX) GL_RouteClass = 0;
  if (GL_RouteClass == 1) AllSigStop();
  src[1] = GL_RouteClass | 0x30;   // Wandlung in ASCII
  TextPanel(xko, yko, src);        // Ausgabe RCL

} // RouteClass()


void DKW_um(uint8_t xko, uint8_t yko) {

  static char sa_b[] = {"a/b"}; // ohne static evt. nok
  static char sc_d[] = {"c/d"};

  GL_DKW_abcd++;
  if (GL_DKW_abcd > DKWMAX) GL_DKW_abcd = 0;

  if (GL_DKW_abcd) TextPanel(xko, yko, sc_d);
  else             TextPanel(xko, yko, sa_b);
} // DKW_um()


void SigZR_um(uint8_t xko, uint8_t yko ) {

  static char s_Z[] = {" Z "}; // ohne static evt. nok
  static char s_R[] = {" R "};

  GL_SigZR++;
  if (GL_SigZR > SIGZRMAX) GL_SigZR = 0;

  if (GL_SigZR) TextPanel(xko, yko, s_R);
  else          TextPanel(xko, yko, s_Z);

} // SigZR_um()


void num2str(uint8_t nmb, char *tstr) { // 0 bis +99
  byte z = (nmb / 10) | 0x30; nmb = nmb % 10;
  byte e =  nmb     | 0x30;
  tstr[2] = e;
  tstr[1] = z;
  if (z == '0') tstr[1] = 'W';
} // num2str()


void Button(byte fx, byte fy) {
  CircleF (fx, fy, 7, DGRAY); // Ring
  CircleF (fx, fy, 5, YELLOW); // Taste
} // Button()


void ButtonCol(byte fx, byte fy, int color) {
  if (StpM[fy][fx] == 0) {             // kein Element, mittig
    CircleF (fx, fy, 6, DGRAY); // Ring
    CircleF (fx, fy, 5, color); // Taste
  }
  else {
    CircleFB (fx, fy, 6, DGRAY); // Ring
    CircleFB (fx, fy, 5, color); // Taste
  }
} // ButtonCol()


void TouchAction(void) {
  int scrX  = 0;
  int scrY  = 0;

  TouchGet(0); // Status
  int check = TouchNotify();  // Statusrueckgabe

  switch (GL_rval) {
    case 1: //MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"
      TouchGet(1); //Get X coorddinates
      scrX = TouchNotify();
      TouchGet(2); //Get Y coorddinates
      scrY = TouchNotify();
      KeyPressKoord(scrX, scrY, 1);   // Auswertung
      break;

    case 2: //MelderUpdate(indicTFdb, DGRAY); // Touch-Feedback "break"
      //KeyPressKoord(scrX, scrY,0);
      break;

    default:
      break;
  } // switch()
} // TouchAction()


void ToggleBMsim(void) {
  if (GL_BMsim) {    // Belegtmeldersimulation aus
    GL_BMsim = 0;
    if (Melder[6].exist) TextInfoPos(Melder[6].x, Melder[6].y, ">          ", 5, 0);
  }
  else {             // Belegtmeldersimulation ein
    GL_BMsim = 1;
    if (Melder[6].exist) TextInfoPos(Melder[6].x, Melder[6].y, "> BMsim", 5, 0);
  }
}


void TrackContacts(void) {
  byte portARM   = 0;
  byte portCRM   = 0;
  uint16_t change    = 0;
  uint16_t bitmask   = 0x0001;
  byte xko       = 0;
  byte yko       = 0;
  byte Ele       = 0;
  uint16_t portsAC   = 0;      // Port A und C vereinigt
  static uint16_t portsAC_L = 0xFFFF; // Belegt bei Start erkennen

#ifdef LOCONET
  if (RMlnt) {
    LnPacket = LocoNet.receive();
    if (LnPacket) LocoNet.processSwitchSensorMessage(LnPacket);
  }
#endif
  portARM = PINA; // Rueckmeldebits lesen
  portCRM = PINC;

  portsAC = (bitreverse(portCRM) << 8) + portARM;

  if (portsAC != portsAC_L) {          // Veraenderungen gegenueber
    // letzter Abfrage?
    change = portsAC ^ portsAC_L;     // Veraenderungen registrieren
    for (int k = 0; k < 16; k++) {
      xko = RMKoord[k].x;
      yko = RMKoord[k].y;
      Ele = StpM[yko][xko];        // B-Melder nur auf Ele 1,2,3

      if (change & bitmask) {      // gibt es Veraenderungen?
        if (portsAC & bitmask) { // von 1 auf 0
          //Frei(xko, yko, Ele);
          RMKoord[k].ReleaseCnt = 4;
        }
        else {                   // von 0 auf 1
          Belegung(xko, yko, Ele);
          RMKoord[k].ReleaseCnt = 0;
        }
      } // if change
      bitmask = bitmask << 1;
    } // for
  }
  portsAC_L = portsAC;
  ReleaseCheck();

} // TrackContacts()


void ReleaseCheck(void) {
  uint8_t a = 0;

  for (int k = 0; k < RMDIM; k++) {
    a = RMKoord[k].ReleaseCnt;
    if (a) {                       // a ungleich 0?
      if (a == 1) {                // Freigabe ?
        uint8_t x = RMKoord[k].x;
        uint8_t y = RMKoord[k].y;
        Frei(x, y, StpM[y][x]);   // Freigabe
        RMKoord[k].ReleaseCnt = 0;
      }
      else {
        (RMKoord[k].ReleaseCnt)--;
      }
    }
  }  // for
} // ReleaseCheck()


uint8_t bitreverse(uint8_t x) { // sketch_mar19a_bitinverse.ino
  uint8_t total = 0;

  for (int n = 0; n < 8; n++) {
    total = total << 1;
    total += x & 1; // modulo operation
    x = x >> 1;
  }
  return total;
} //bitreverse()


int Border(int x) {
  if (x == 0) return (-1);        // left
  if (x == GL_xmax) return (1);   // right
  return (0);
} // Border()


int EndeFstr(int x, uint8_t Ele) {
  if (Ele & FSTRBEL)
  { // Fstr. ja
    if (Ele & FSTRSTART)
    { // Start einer Fstr.
      return (0);    // kein Ende Fstr.
    }
    else
    { // Bedingungen erfuellt, Ende Fstr.
      return (1);
    }
  }
  else return (0);  // keine Fstr.
} // EndeFstr.


void RCFrei(int x, int y, uint8_t Ele) {
  Frei(x, y, Ele);
} // RCFrei()


void Frei(int x, int y, uint8_t Ele) {

  uint8_t Sig      = 0;
  uint8_t SigFlag  = 0;
  //uint8_t Richtung = 0;

  Sig = StpS[y][x] & 0x1F;

  switch (Sig) {
    case 30:
    case 28:
    case 26: GL_Richtung = 0;
      SigFlag  = 1;
      break;
    case 31:
    case 29:
    case 27: GL_Richtung = 1;
      SigFlag  = 1;
      break;
    default:
      break;
  }

  StpM[y][x] = Ele & DETECTRES;  // setzt 0 in MSB von Ele = Frei

  if (Ele & FSTRBEL) TrackLight(x, y, YELLOW); // aus Rot wird Gelb wenn Fstr.
  else               TrackLight(x, y, DGRAY); // aus Rot wird Grau wenn keine Fstr

  SignalHp0(x, y);    // Haltfall bei Freimeldung

  if (GL_RouteClass > 3) {  // bei RCL <= 2 keine Fstr. Aufloesung
    if (Border(x)) {
      if (EndeFstr(x, Ele)) {
        uint8_t i = suche_i(x, y);          // i: 1 - 24, index 0 - 23
        if (StpM[RMKoord[i - 1].Ry][RMKoord[i - 1].Rx] & DETECTSET)
        { // Startabschnitt belegt
        }                     // keine Aufloesung
        else { // Startabschnitt frei
          newCheckSignal (RMKoord[i - 1].Rx, RMKoord[i - 1].Ry); // Begin der Fstr. Aufloesung
        }
      } // if EndeFstr
    } // if Border
  } // if RCL

  // Wiederholungssperre
  uint8_t i = suche_i(x, y);    // i 1 - 24, index 0 - 24
  RMKoord[i - 1].Rx = 0;
  RMKoord[i - 1].Ry = 0;
  // Wiederholungssperre


  if (Ele & FSTRBEL) { // Pruefung Zielsignal, wenn frei keine Aufloesung

  } // if Fstr.
} // Frei()


void RCBelegung(int x, int y, uint8_t Ele) {
  uint8_t Sig      = 0;
  uint8_t SigFlag  = 0;
  //uint8_t Richtung = 0;

  Sig = StpS[y][x] & 0x1F;

  switch (Sig) {
    case 26:
    case 30:
    case 28: GL_Richtung = 0;
      SigFlag  = 1;
      break;
    case 27:
    case 31:
    case 29: GL_Richtung = 1;
      SigFlag  = 1;
      break;
    default:
      break;
  }


  if (StpM[y][x] & DETECTSET) return; // sonst doppelt moeglich, Belegung mit/ohne Loknr.
  TrackLight(x, y, DGRAY);         // ggf Fstr.Strich loeschen
  StpM[y][x] = Ele | DETECTSET;    // Besetzteintrag

  //Tracker(x,y,StpM[y][x]);
  if (GL_DebOpt & 0b00001000) { // 8
    Serial.print(' '); Serial.println(__LINE__); CheckRMArray();
  }

  uint8_t i = suche_i(x, y);
  if ((i > 0) && (RMKoord[i - 1].RevRel)) {  // Fragment: Aufloesung im Kopfbahnhof
    Serial.print(F("Aufloeseflag: "));
    Serial.println(RMKoord[i - 1].RevRel);
  }

  if ((Ele & FSTRBEL) || SigFlag) {      // entweder Ele und in Fstr ODER Sig. (Fahrstrasse?)

    if (i > 0) {

      if (StpM[RMKoord[i - 1].Ry][RMKoord[i - 1].Rx] & DETECTSET)
      { // Startabschnitt belegt
      }
      else {                     // Startabschnitt ist frei
        switch (GL_RouteClass) {
          case 0:
          case 1:
          case 2: return;
            break;
          case 3: // lese Beginn der Fstr., Zuggesteuerte Aufloesung
            newCheckSignal (RMKoord[i - 1].Rx, RMKoord[i - 1].Ry);
            break;

          case 4: // Aufloesung bei Belegt wenn kein Border
            // Auflösung mit Frei wenn Border
            if (Border(x)) {
            }
            else {
              newCheckSignal (RMKoord[i - 1].Rx, RMKoord[i - 1].Ry);
            }
            break;
          default:
            break;
        } // switch RCL
      }  // Startabschnitt frei
    } // if i
  } // if Fstr. oder SigFlag

} // RCBelegung()



void Belegung(int x, int y, uint8_t Ele) {

  uint8_t Sig      = 0;
  uint8_t SigFlag  = 0;
  //uint8_t Richtung = 0;

  Sig = StpS[y][x] & 0x1F;

  switch (Sig) {
    case 26:
    case 30:
    case 28: GL_Richtung = 0;
      SigFlag  = 1;
      break;
    case 27:
    case 31:
    case 29: GL_Richtung = 1;
      SigFlag  = 1;
      break;
    default:
      break;
  }

  StpM[y][x] = Ele | DETECTSET;          // Besetzteintrag
  TrackLight(x, y, RED);                 // Abschnitt wird rot

  Tracker(x, y, StpM[y][x]);
  uint8_t i = suche_i(x, y);               // i ist 1 - 24, Index 0 - 23
  if ((i > 0) && (RMKoord[i - 1].RevRel)) {
    Serial.print(F("Aufloeseflag: "));
    Serial.println(RMKoord[i - 1].RevRel);
  }

  if ((Ele & FSTRBEL) || SigFlag) {      // entweder Ele und in Fstr ODER Sig. (Fahrstrasse?)

    if (i > 0) {

      if (StpM[RMKoord[i - 1].Ry][RMKoord[i - 1].Rx] & DETECTSET)
      { // Startabschnitt belegt
      }
      else {                     // Startabschnitt ist frei
        switch (GL_RouteClass) {
          case 0:
          case 1:
          case 2: return;
            break;
          case 3: // lese Beginn der Fstr., Zuggesteuerte Aufloesung
            newCheckSignal (RMKoord[i - 1].Rx, RMKoord[i - 1].Ry);
            break;
          case 4: // Aufloesung bei Belegt wenn kein Border
            // Auflösung mit Frei wenn Border
            if (Border(x)) {
            }
            else {
              newCheckSignal (RMKoord[i - 1].Rx, RMKoord[i - 1].Ry);
            }
            break;
          default:
            break;
        } // switch RCL
      }  // Startabschnitt frei
    } // if i
  } // if Fstr. oder SigFlag
} // Belegung()



uint8_t suche_i(int sx, int sy) {
  int i = -1;
  for (int k = 0; k < RMDIM; k++) {
    if ((RMKoord[k].x == sx) && (RMKoord[k].y == sy)) {
      i = k;
      break;
    }
  } // for
  return (i + 1); // (i);
} // suche_i()


void AllSigStop(void) {
  // Aufruf bei RCL0 -> RCL1   und beim Start
  //Serial.println();  Serial.println("All stop:");
  for (int x = 0; x < XDIM + 1; x++) {
    for (int y = 0; y < YDIM; y++) {
      if (StpS[y][x] & 0x1F) {
        SignalHp0(x, y);
        //Serial. print("x.y,Ele: ");Serial.print(x); Serial. print(',');
        //                          Serial.print(y); Serial. print(',');
        //                           Serial.println(StpS[y][x] & 0x1F);
      }
    }
  }
} // AllSigStop()


void SimBelegt(byte fx, byte fy) {
  // die Abschnitte (1,2,3) sind nur ausleuchtbar mit belegt
  // wenn als Belegtmelder deklariert
  // keine Unterscheidung echte oder simulierte Belegtmeldung
  // keine Auflöseaktivität, wohl aber Fahrwegprüfung auf belegt

  uint8_t Ele = StpM[fy][fx];
  uint8_t vorhanden = 0;
  uint8_t BMindex   = 0;

  for (int k = 0; k < RMDIM; k++) {
    if ((RMKoord[k].x == fx) && (RMKoord[k].y == fy)) {
      vorhanden = 1;
      BMindex = k;
      break;
    }
  } // for

  if (vorhanden) {
    if (Ele & DETECTSET) {               // besetzt,
      StpM[fy][fx] = Ele & DETECTRES;  // frei
      if (Ele & FSTRBEL) TrackLight(fx, fy, YELLOW);
      else               TrackLight(fx, fy, DGRAY);
    }
    else {                               // frei,
      StpM[fy][fx] = Ele | DETECTSET;  // belegt
      TrackLight(fx, fy, RED);
    }
    Text_CR(5);
    AnzeigeBM(BMindex + 1, 1); // Korrektur auf Pin-Nr.
  } // if vorhanden

  // Belegtbit Toggle & Anzeige

}


// EEP-Proc. aus FP_SoftwareBeta45.ino
void csvStart(void) {
  ReadEEPhdStrPv();
  if (EEPcheck()) { // check 1
    Serial.println(F("EEProm check 1 failed, csv from Flash"));
  }
  else { // check 1
    Serial.println(F("EEProm check 1 ok, csv from EEPROM"));
  }
} // csvStart()


//------------------------------------------------------------------------

void loop()    {
  static byte plife = 0;
  static byte Startdelay = 10;

  Serial2.write(TextColourYe, 4); delayS2();
  TextHeight[3] = 1;
  Serial2.write (TextHeight, 4); delayS2();

  Serial2.write(TextBackGrnd, 4);
  Serial2.write(TextColourBl, 4);
  TextFont[3] = 5; Serial2.write(TextFont, 4);

  //if (Melder[6].exist) TextPanel(Melder[6].x,Melder[6].y,stri);           // Ausgabe der SW-Version

  csvCheck();                     // Gleisbild aus csv-Daten zeichnen

  if (Melder[6].exist) TextPanel(Melder[6].x, Melder[6].y, stri);         // Ausgabe der SW-Version
  if (Melder[6].exist) TextInfoPos(Melder[6].x, Melder[6].y, FirstLine, 1, 0); // Ausgabe der CSV-Version

  Serial.print(F("xmax,ymax: ")); Serial.print  (GL_xmax); Serial.print(',');
  Serial.println(GL_ymax);

  GL_pixXmax = (GL_xmax + 2) * FELDSX;
  GL_pixYmax = (GL_ymax + 1) * FELDSY;

  //TextKoord();     // Nummerung der Stelltischfelder Zaehlhilfe Entw.

  for (int Y = FELDSY; Y < GL_pixYmax; Y = Y + FELDSY) { // Raster Stelltisch
    Linie(0, Y, GL_pixXmax, Y, DGRAY);
  }
  for (int X = 0; X < GL_pixXmax; X = X + FELDSX) {
    Linie(X, 0, X, GL_pixYmax, DGRAY);
  }

  if (EEPROM.read(LogoSize) == 'l') { // bei anderen Werten als "el" Logo gross
    FeldFarbe2(0, 0, 0xFF80);         // Ersatz fuer Logo wg Ladezeit
    DrawKey(0, 0, 1, BLACK, "DiMo");
  }
  else DisplayLogo(0, 0);             // Normal 0,0

  TouchSet(0);                        // Enable Touchscreen
  TouchFieldAll();

#ifndef LOCONET
  do {
    XpressNet.receive();
    delay(200);
  }
  while (GL_XBusWait); // wenn 1, warten
#endif

  AllSigStop();
  DebugStartInfo();

  //LinkTest();
  uart3dOut(0x20);   // RailCom Start
#ifndef LOCONET
  Serial2.write(TextRCBackGd, 4);
#else
  if (DisplayBaud <= 0x08) Serial2.write(TextRCBackGd, 4);
#endif

  // --------------------------------------------------------------
  while (1) {
    // ar1[999] = 5; Test, wenn aktiv 2405 Byte fuer lok. Var., nicht aktiv 3405 Byte
    if (zeitabgelaufen(startzeitC, t05sec)) {
#ifndef LOCONET
      XpressNet.receive();  //permanent update the library
#else
      LnPacket = LocoNet.receive(); //permanent update the library
      if (LnPacket) LocoNet.processSwitchSensorMessage(LnPacket);
#endif
      startzeitC = currentT1();            // stetige Wiederholung
    }
    // --------------------------------------------------------------
    if (zeitabgelaufen(startzeitB, t05sec)) {  // 05sec
      plife++;

      if (plife & 0x01)  {
        MelderUpdate(indicRun, DGRAY);
#ifndef LOCONET
        XpressNet.getLocoInfo (0, 3);
#endif
      }
      else {
        if (Startdelay) {
          MelderUpdate(indicRun, RED);
          Startdelay--;
        }
        else MelderUpdate(indicRun, WHITEDIM3);
      }
      TouchAction();
      startzeitB = currentT1();          // stetige Wiederholung
    }
    // --------------------------------------------------------------
    if (zeitabgelaufen(startzeitA, t1_1sec)) {  //t1_1sec, t3sec
      TrackContacts();
      RCFetch();
#ifndef LOCONET
      RD_Queue(); // wenn Queue gefuellt erfolgt Ausgabe XBus
#else
      MelderUpdate(indicTFdb, DGRAY);
#endif
      if (GLOB_FwegAuftrag) FwegListe();

      startzeitA = currentT1();         // stetige Wiederholung
    }
    // --------------------------------------------------------------
    if (zeitabgelaufen(startzeitD, t3sec)) {  // t3sec
      GL_Bediensperre = 0;
      // einmalig nach Weichen- Signal- und Magnetstellung
    }

    //RCFetch();

  } // while()
} // loop()

//------------------------------------------------------------------------

void DebugStartInfo(void) {
  if (GL_DebOpt & 0b0001) {  // 1
    AdrDump();
    SigDump();
  }

  if (GL_DebOpt & 0b0010) { // 2
    FWegDump();
    BMdump();
  }
  if (GL_DebOpt & 0b0100) { // 4
    CheckLinkArray();
    TheKeys();
  }
} // DebugStartInfo()


//------------------------------------------------------------------------
#ifndef LOCONET
void WR2Queue(uint8_t Hadr, uint8_t Ladr, uint8_t Val, uint8_t swDel) {
  //GL_TouchLock = true; //startzeitD = currentT1();
  //MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"

  XBusQueue[WRptr] = Hadr;  WRptr++; WRptr = WRptr & PTRMSK;
  XBusQueue[WRptr] = Ladr;  WRptr++; WRptr = WRptr & PTRMSK;
  XBusQueue[WRptr] = Val;   WRptr++; WRptr = WRptr & PTRMSK;
  XBusQueue[WRptr] = swDel; WRptr++; WRptr = WRptr & PTRMSK;

  //MelderUpdate(indicTFdb, YELLOW); // Touch-Feedback "make"
}


void toQueue(uint16_t Adr, uint8_t Lage1, uint8_t Lage2, uint8_t Swap2_1) {

uint8_t Swap1 = Swap2_1 & 0x01;
uint8_t Swap2 = Swap2_1 >> 1;

WR2Queue(highByte(Adr), lowByte(Adr), 0x08 | (Swap1 ^ (0x01 & Lage1)), 0);
if (Lage2 != 0xFF) {  // 
   Adr++;
   WR2Queue(highByte(Adr), lowByte(Adr), 0x08 | (Swap2 ^ (0x01 & Lage2)), 0);
   }  
} // toQueue()


void RD_Queue(void) {
  static uint8_t valH, valL, val3, val4;

  if (WRptr != RDptr) {
    valH = XBusQueue[RDptr]; RDptr++; RDptr = RDptr & PTRMSK;
    valL = XBusQueue[RDptr]; RDptr++; RDptr = RDptr & PTRMSK;
    val3 = XBusQueue[RDptr]; RDptr++; RDptr = RDptr & PTRMSK;
    val4 = XBusQueue[RDptr]; RDptr++; RDptr = RDptr & PTRMSK;

    XpressNet.setTrntPos(valH, valL, val3);
    Debug32(valH, valL, val3);
    MelderUpdate(indicTFdb, GRAY); // Touch-Feedback "break"
  }
} // RD_Queue()
#endif


//------------------------------------------------------------------------
void MelderUpdate(uint8_t indicator, uint16_t color) {
  int KorX = -15;
  int KorY = 0;
  int rad  = 5;
  int fx   = 0;
  int fy   = 0;
  int CenterX = 0;
  int CenterY = 0;
  bool drawit = false;

  switch (indicator) {
    case indicTFdb:
      if (Melder[1].exist) {
        KorY = - 8;
        fx = Melder[1].x; fy = Melder[1].y;
        drawit = true;
      }
      break;
    case indicRun:
      if (Melder[1].exist) {
        KorY = 8;
        fx = Melder[1].x; fy = Melder[1].y;
        drawit = true;
      }
      break;
    case indicTPwr:
      if (Melder[2].exist) {
        KorY = - 8;
        fx = Melder[2].x; fy = Melder[2].y;
        drawit = true;
      }
      break;
    case indicBusy:
      if (Melder[2].exist) {
        KorY = 8;
        fx = Melder[2].x; fy = Melder[2].y;
        drawit = true;
      }
      break;
    default:
      break;
  } // switch

  if (drawit) {
    CenterX = fx * FELDSX + (FELDSX / 2) + KorX;
    CenterY = fy * FELDSY + (FELDSY / 2) + KorY;

    DrawFilCirc[2] = CenterX >> 8; DrawFilCirc[3] = CenterX & 0x00FF;
    DrawFilCirc[4] = CenterY >> 8; DrawFilCirc[5] = CenterY & 0x00FF;
    DrawFilCirc[6] = rad     >> 8; DrawFilCirc[7] = rad     & 0x00FF;
    DrawFilCirc[8] = color   >> 8; DrawFilCirc[9] = color   & 0x00FF;
    Serial2.write (DrawFilCirc, 10); delayS2();
  }
} // MelderUpdate()

//------------------------------------------------------------------------


void ProcDauertest(void) {
  static int TstCycle = 0;
  static int TstStep  = 100;
  static byte Flist[] = {3, 5, 0};

  if (Dauertest) {
    Text_CR(5);
    i2str(1, TstStep);

    GLOB_FwegAuftrag = Flist[TstCycle];
    TstCycle++;
    if (Flist[TstCycle] == 0) TstCycle = 0;

    TstStep--;
    if (TstStep == 0) Dauertest = false;
  }
} // Dauertest()


//--------------------------------------------------------------------------------------------
#ifndef LOCONET
void notifyXNetStatus (uint8_t State)
{
  digitalWrite(ledpin, State); // State 0: keine Verbindung
  if (State) GL_XBusWait = 0;
  Serial.print(F("XBusState:")); Serial.println(State, HEX);
}

//--------------------------------------------------------------------------------------------
void notifyXNetPower (uint8_t State)
{
  switch (State) {
    case csNormal:          MelderUpdate(indicTPwr, BLUE); break;
    case csTrackVoltageOff: MelderUpdate(indicTPwr, RED);  break;
    case csEmergencyStop:   MelderUpdate(indicTPwr, BLUE); break;
    case csShortCircuit:    MelderUpdate(indicTPwr, RED);  break;
    case csServiceMode:     MelderUpdate(indicTPwr, RED);  break;
  }
} // notifyXNetPower()

//--------------------------------------------------------------------------------------------

void notifyTrnt(uint8_t Adr_High, uint8_t Adr_Low, uint8_t Pos) {

  //static byte cnt = 0;
  uint16_t    Adr = 0;

  Adr = (Adr_High << 8) + Adr_Low;
  Adr++;  // Versatz Korr. !!!
  GL_cnt++;
  //Serial.print("nfy ");Serial.print(Adr);Serial.print(' '); Serial.print(Pos);
  //Serial.print(' '); Serial.println(GL_cnt);

} // notifyTrnt()

//--------------------------------------------------------------------------------------------
void notifyLokAll(uint8_t Adr_High, uint8_t Adr_Low, boolean Busy,
                  uint8_t Steps, uint8_t Speed, uint8_t Direction,
                  uint8_t F0, uint8_t F1, uint8_t F2, uint8_t F3, boolean Req )
{
  if (Busy) MelderUpdate(indicBusy, RED);
  else      MelderUpdate(indicBusy, BLUE);
}
#endif

//--------------------------------------------------------------------------------------------
void PointRequest(void) {
  uint16_t Adr = 0;

  Serial.println();
  Serial.println(F("Digital-Adressen plus notify:"));
  Serial.print(F("GL_cnt: ")); Serial.println(GL_cnt);

  for (int y = 0; y < YDIM; y++) {
    for (int x = 0; x < (XDIM + 1); x++) {
      Adr = StpA[y][x];
      if (Adr) {
        Answer = false;
        Serial.print(Adr); Serial.println(',');
#ifndef LOCONET
        XpressNet.getTrntInfo (highByte(Adr), lowByte(Adr));
#else
        LocoNet.reportSwitch (Adr);
#endif
        while (Answer) {};
      }
    } // for x
  } // for y
  Serial.println();
} // PointRequest()

//--------------------------------------------------------------------------------------------

void SetTurnout(uint16_t AdrData, uint8_t altLage) {

uint8_t  Wdelay =  AdrData >> ADRdSHT; // 2bit, 0..3
uint8_t  SwSwap = (AdrData >> ADRsSHT) & 0x01;
uint16_t Adr    =  AdrData & ADRMASK; // 0..2048
uint8_t  HAdr   = 0;
uint8_t  LAdr   = 0;

#ifndef LOCONET
Adr--; // Versatz !!!!!!!!!!!!!!!
HAdr = highByte(Adr);  LAdr = lowByte(Adr);

switch (altLage) {
case 0: // ist ohne Lage      
      if (SwSwap)WR2Queue(HAdr, LAdr, 0b1000,Wdelay ); // umgekehrt
      else       WR2Queue(HAdr, LAdr, 0b1001,Wdelay ); // normal
      break;
case 1: // ist gerade     
      if (SwSwap) WR2Queue(HAdr, LAdr, 0b1001, Wdelay); // umgekehrt
      else        WR2Queue(HAdr, LAdr, 0b1000, Wdelay); // normal
      break;
case 2: // ist Bogen      
      if (SwSwap) WR2Queue(HAdr, LAdr, 0b1000, Wdelay); // umgekehrt
      else        WR2Queue(HAdr, LAdr, 0b1001, Wdelay); // normal
default:
      break;
#else
switch (altLage) {
case 0: // ist ohne Lage      
      if (SwSwap) requestSwitch(Adr, RND_ROT, Wdelay); // umgekehrt
      else        requestSwitch(Adr, GRD_GRN, Wdelay); // normal
      break;
case 1: // ist gerade     
      if (SwSwap) requestSwitch(Adr, GRD_GRN, Wdelay); // umgekehrt
      else        requestSwitch(Adr, RND_ROT, Wdelay); // normal
      break;
case 2: // ist Bogen      
      if (SwSwap) requestSwitch(Adr, RND_ROT, Wdelay); // umgekehrt
      else        requestSwitch(Adr, GRD_GRN, Wdelay); // normal
default:
      break;
#endif      
} // switch
} // SetTurnout()


uint8_t GetSwapDW(int fx, int fy) {
uint8_t  SwSwap1 = (StpA[fy][fx] >> ADRsSHT) & 0x01;
uint16_t AdrData = GetAdrDatDKWcd(fx, fy);  
uint8_t  SwSwap2 = (AdrData >> ADRsSHT) & 0x01;

return ((SwSwap2 << 1) | SwSwap1);
} // GetSwapDW()

//--------------------------------------------------------------------------------------------
// The End
