// F-Macros
// 1. Timeout
#include "Loconet.h"
#include "csvModul.h"

//#include <csvstr.h>

void binLoadRAM   (void);   // in diesem Modul definiert
void csv2EEPROM   (void);   // in diesem Modul definiert
void writeHdStrPV (void);   // in diesem Modul definiert
uint8_t XBusAdrIn (void);   // in diesem Modul definiert
uint8_t RCLnewIn  (void);   // in diesem Modul definiert
#ifdef LOCONET
uint16_t NumIn    (void);   // in diesem Modul definiert
#endif

#define  ASCMSK       0xDF    // Bit 5 = 0, -> ASCII gross
#define  CR           0x0D
#define  LF           0x0A

#ifndef LOCONET
#define  TIMEOUTshort 1000    // die Klasse String beendet Eingaben ...
#else
#define  TIMEOUTshort 4000    // die Klasse String beendet Eingaben ...
uint16_t input;
#endif
#define  TIMEOUTlong  5000    // durch Zeitueberschreitung

uint16_t MGL_csvLen    =  0;  // Bytes read from terminal

String   displays; //""; //xxxx xxxxx xxxxx xxxxx xxxxx xxxxx xxxxx xxxx Test ";

void csvNew(void) {           // Aufruf durch xx.ino, HdStrPV dann schreiben, wenn invalid
  char       in[] = {"..."};
  char       ch   = ' ';
  extern uint8_t GL_XBusAdr;
  uint8_t RCLvalue = 0;
  extern uint8_t GL_DebOpt;

  Serial.setTimeout(TIMEOUTshort);

  Serial.println();
  Serial.println(F("-> Eingabe c oder C fuer Laden csv Datei via Terminal "));
#ifndef LOCONET
  Serial.print  (F("-> Eingabe a oder A fuer Eingabe XBus-Adresse: "));
#else
#ifndef STANZLN
  Serial.println(F("-> Eingabe a/A fuer Stellungsanzeige ueber LocoNet de/aktivieren"));
#endif
  Serial.print  (F("-> Eingabe m/M fuer Rueckmelder ueber Direktanschluss per Hardware/LocoNet: "));
#endif
  Serial.readBytes(in, 1); ch = in[0];
  Serial.println(ch);

  switch (ch) {
    case 'c':
    case 'C': Serial.print(F("-> csv-Datei neu? Eingabe y oder Y: "));
      Serial.readBytes(in, 1); ch = in[0]; // mit Timeout  ...
      Serial.println(ch);

      if (((ch & ASCMSK) == 'Y')) {// if 2
        Serial.println(F("Laden der csv-Datei, warten auf Terminal ..."));
        binLoadRAM();

      } // if 2
      else { // Eingabe 2 nicht y oder Y, oder Timeout
        Serial.println(F("Start 2 Stw ..."));
      }
      break;
#ifndef LOCONET
    case 'a':                               // Adr. XBus erst aenderbar, wenn csv geladen
    case 'A': Serial.print(F("-> XBus-Adresse neu? Eingabe y oder Y: "));
      Serial.readBytes(in, 1); ch = in[0]; // mit TimeOut
      Serial.println(ch);

      if (((ch & ASCMSK) == 'Y')) {// if 2
        Serial.print(F("XBus-Adresse alt: "));
        Serial.println(EEPROM.read(XAHDSTRPV));
        Serial.print(F("-> Adresse neu: "));

        GL_XBusAdr = XBusAdrIn(); // Hier Eingabe von zwei Stellen ohne Timeout
        if ((GL_XBusAdr > 0) && (GL_XBusAdr < 31)) { // if 3
          EEPROM.write(XAHDSTRPV, GL_XBusAdr);
        }
        else Serial.println(F("Adresse unveraendert."));
      } // if 2
      else { // Eingabe 2 nicht y oder Y, oder Timeout
        Serial.println(F("Start 2 Stw ..."));
      }
      break;
#else
#ifndef STANZLN
    case 'a':
      Serial.println(F("-> Stellungsanzeige ueber LocoNet inaktiv"));
      EEPROM.write(SALoconet, 0);
      break;
    case 'A':
      Serial.println(F("-> Stellungsanzeige ueber LocoNet aktiv"));
      EEPROM.write(SALoconet, 1);
      break;
#endif      
    case 'm':
      Serial.println(F("-> Rueckmelder ueber Direktanschluss per Hardware"));
      EEPROM.write(RMLoconet, 0);
      break;
    case 'M':
      Serial.println(F("-> Rueckmelder über LocoNet-Nachrichten"));
      EEPROM.write(RMLoconet, 1);

      Serial.print(F("-> Rueckmelder-Daten aendern (Eingabe j/J)? "));
      Serial.readBytes(in, 1); ch = in[0]; // mit Timeout  ...
      Serial.println(ch);

      if (((ch & ASCMSK) == 'J')) {//
        Serial.print(F("   Bisheriger Rueckmelder-Offset1: "));
        EEPROM.get(RMOffset1, input); Serial.println(input);
        Serial.print(F("   Neuer Rueckmelder-Offset1:      "));
        input = NumIn(); Serial.println();
        if (input <= RMOffMax) EEPROM.put(RMOffset1, input);
        else                   Serial.println(F("   Wert unveraendert oder ungueltig"));

        Serial.print(F("   Bisheriger Rueckmelder-Offset2: "));
        EEPROM.get(RMOffset2, input); Serial.println(input);
        Serial.print(F("   Neuer Rueckmelder-Offset2:      "));
        input = NumIn(); Serial.println();
        if (input <= RMOffMax) EEPROM.put(RMOffset2, input);
        else                   Serial.println(F("   Wert unveraendert oder ungueltig"));

        Serial.print(F("   Bisheriger RM-Startstatus:  "));
        input = EEPROM.read(RMStStat); if (input) Serial.println(F("frei")); else Serial.println(F("belegt"));
        Serial.print(F("   Neuer RM-Startstatus (0/1): "));
        input = NumIn(); Serial.println();
        if (input <= 1) {
          if (input) EEPROM.write(RMStStat, 0); else EEPROM.write(RMStStat, 0xFF);
        }
        else Serial.println(F("   Wert unveraendert oder ungueltig"));
      }
      else Serial.println(F("   Start 3 Stw ..."));
      break;
#endif
    case 'r':         // verborgen (keine Anzeige), RouteClass neu eingeben
    case 'R':
      Serial.print(F("-> Route Class neu? Eingabe y oder Y: "));
      Serial.readBytes(in, 1); ch = in[0]; // mit TimeOut
      Serial.println(ch);

      if (((ch & ASCMSK) == 'Y')) {//
        Serial.print(F("-> Route Class alt: "));
        Serial.println(EEPROM.read(RCLeep));
        Serial.print(F("-> Route Class neu: "));

        RCLvalue = RCLnewIn(); Serial.println(RCLvalue);
        EEPROM.write(RCLeep, RCLvalue);
      }
      else { // Eingabe nicht y oder Y, oder Timeout
        Serial.println(F("Start 3 Stw ..."));
      }
      break;

    case 'd':         // verborgen (keine Anzeige), Debug-Option setzen
    case 'D':
      Serial.print(F("-> Debug-Option neu? Eingabe y oder Y: "));
      Serial.readBytes(in, 1); ch = in[0]; // mit TimeOut
      Serial.println(ch);

      if (((ch & ASCMSK) == 'Y')) {//
        Serial.print(F("-> Debug-Option alt: "));
        Serial.println(EEPROM.read(DEBUGOPT));
        Serial.print(F("-> Debug-Option neu: "));

        GL_DebOpt = XBusAdrIn(); Serial.println(GL_DebOpt);  // Eingabe-Proc. uebernommen
        EEPROM.write(DEBUGOPT, GL_DebOpt);
      }
      else { // Eingabe nicht y oder Y, oder Timeout
        Serial.println(F("Start 3 Stw ..."));
      }
      break;

    case 'l':         // verborgener Wert, jeder andere Wert bedeutet 'L', Logo gross
    case 'L': EEPROM.write(LogoSize, ch);
    // hier kein break, laeuft in default
    default:
      // Start mit unveraenderten csv-Daten
      Serial.println(F("Start 1 Stw ..."));
      break;
  } // switch

  //Serial.println(in);
} // csvNew()


void binLoadRAM(void) {

#define  CSVMAXLEN  3072

  int      linecnt = 0;
  int      i       = 0;
  String   KbdIn;

  Serial.println(F("CSV vom Terminal in RAM lesen, CSV neu:"));
  Serial.println();
  //Serial.println("-> IDE: Disconnect Serial Monitor (wenn verwendet)");
  Serial.println(F("-> PC:  Terminal starten, (Ausgabe Arduino auf Terminal Fenster) ..."));
#ifndef LOCONET
  Serial.println(F("-> Terminal: 9600 Bd, 8n1, Send File ... (Auswahl)"));
#else
  const long baudrate = BaudRate0;
  Serial.print(F("-> Terminal: ")); Serial.print(baudrate); Serial.println(F(" Bd, 8n1, Send File ... (Auswahl)"));
#endif
  Serial.println(F("-> Terminal: Option Binary anklicken ..."));
  Serial.println(F("-> Terminal: csv-Datei Oeffnen ..."));

  Serial.setTimeout(TIMEOUTshort);

  while (Serial.available() <= 0) { };
  if (Serial.available() > 0) { // if 1

    displays = Serial.readString();    //csv-Datei komplett lesen
    //
    // HIER, WENN TIMEOUT
    //
    for (i = 0; i < CSVMAXLEN; i++) {      // Info-Ausgabe csv
      if (displays.charAt(i) == CR) linecnt++;
      if (displays.charAt(i) == 0) break;
      Serial.print((char)displays.charAt(i));
    }
    MGL_csvLen = i;
    Serial.println();
    Serial.print(F("Linecount: ")); Serial.println(linecnt);
    Serial.print(F("Bytecount: ")); Serial.println(i);
    Serial.println(F("csv in EEPROM ... "));

    Serial.println(F("EEPROM write? (y oder Y)"));         // letzte Abfrage
    while (Serial.available() <= 0) { };
    KbdIn = Serial.readString();                     // Eingabe ohne TimeOut
    Serial.println(KbdIn);
    if ((KbdIn[0] & ASCMSK) == 'Y') {
      Serial.print(F("writing ... "));

      csv2EEPROM();

      Serial.println(" ok.");
    }
    else {
      Serial.println("EEPROM unveraendert.");
    }
    delay(1000);
  } // if 1, read csv via Terminal
} // binLoadRAM()



void csv2EEPROM(void) {
  uint16_t EEPptr = EEPpos;

  Serial.println(F("csv in EEPROM schreiben, 1. Zeile: "));
  for (int i = 0; i < CSVMAXLEN; i++) {      // Info-Ausgabe 1.Zeile
    if (displays.charAt(i) == CR) break;
    else Serial.print(displays.charAt(i));
  }
  Serial.println();
  Serial.print(F("WRITE ... "));

  for (uint16_t i = 0; i < MGL_csvLen; i++) {     //  csv Schreiben ...
    EEPROM.write(EEPptr, displays.charAt(i));  // (adr, val)
    EEPptr++;
  }
  EEPROM.write(EEPptr, CR);     // CRLF wg. neue Datei < alte Datei
  EEPptr++;
  EEPROM.write(EEPptr, LF);
  EEPptr++;
  EEPROM.write(EEPptr, 0xFF);  // Ende-Kennung im EEPROM schreiben
  EEPptr++;
  EEPROM.write(EEPptr, 0xFF);
  EEPptr++;

  Serial.println("csv done. ");

  writeHdStrPV();                                 // ... dann check und ggf. HdStrPV in EEPROM

} // csv2EEPROM()


void writeHdStrPV (void) {                            // HdStrPV nur schreiben wenn HdStrPV nicht erkannt
  uint16_t EEPptr = 0;

  Serial.println();
  if (EEPcheck()) {
    // EEProm check Failed
    Serial.println("EEPHdStrPV nicht vorhanden");
    Serial.print(F("write HdStrPV ... "));
    for (int i = 0; i < HDSTRPVLEN; i++) {
      uint8_t fetch  = pgm_read_byte_near(HdStrPV + i);
      EEPROM.write(EEPptr, fetch);  // (adr, val)
      EEPptr++;
    } // for
    Serial.println(F("HdStrPV done. "));
  } // if
  else Serial.println(F("EEPHdStrPV vorhanden"));
} // printHdStrPV()


uint8_t RCLnewIn() { //
#define  ADIM   8
  int        inByte    = 0;
  uint8_t      rueckgabe = 0;
  int                i = 0;
  char sarray[ADIM]    = "";

  do {
    if (Serial.available() > 0)
    {
      inByte = Serial.read();
      Serial.write((char)inByte); // Serial.print((char)inByte); gleiches Verhalten
      sarray[i] = inByte; i++; i = i & 0x07;
      if (inByte == 0x0D) {
        sarray[i - 1] = 0;
        rueckgabe = abs (atoi(sarray));
        break;
      }
    }
  } while (1);

  return (rueckgabe);
} // RCLnewIn()


uint8_t XBusAdrIn() { // Input 0 bis 255, keine Cursor-Steuerung, keine Korrektur
#define  ADIM   8
  int             i = 0;
  int        inByte = 0;
  char sarray[ADIM] = "";
  uint8_t    target = 0;

  do {
    if (Serial.available() > 0)
    {
      inByte = Serial.read();
      Serial.write((char)inByte); // Serial.print((char)inByte); gleiches Verhalten
      sarray[i] = inByte; i++; i = i & 0x07;
      if (inByte == 0x0D) {
        sarray[i - 1] = 0;
        target = abs (atoi(sarray));
        break;
      }
    }
  } while (1);

  return (target);
} // XBusAdrIn()

#ifdef LOCONET
uint16_t NumIn() { // Input 0 bis 4095, keine Cursor-Steuerung, keine Korrektur
#define  ADIM   8
  int             i = 0;
  int        inByte = 0;
  char sarray[ADIM] = "";
  uint16_t   target = 0;

  do {
    if (Serial.available() > 0)
    {
      inByte = Serial.read();
      Serial.write((char)inByte); // Serial.print((char)inByte); gleiches Verhalten
      sarray[i] = inByte; i++; i = i & 0x07;
      if (inByte == 0x0D) {
        if (sarray[0] == 0x0D) return 0xFFFF;
        sarray[i - 1] = 0;
        target = abs (atoi(sarray));
        break;
      }
    }
  } while (1);
  return (target);
} // NumIn()
#endif
