// Modul ab 1.02.2019
// Zweck ist Initialisierung der Stellpultgrafik
// csv aus Flash neues csv-File
// F-Macros D83.ino
// Var. csvalue statt adr

#include "csvParser.h"
#include "csvModul.h"

uint8_t EEPcheck(void);
void    csvFlashRead(void);
void    csvEEPread(void);
void    csvParser (char *);
int     parserM(char *);
int     parserA(char *);
int     parserT(char *);
int     parserF(char *);
void    FarbfelderInit(uint8_t xko, uint8_t yko, char *ts);
void    CheckColon(char *str, uint8_t x, uint8_t y);

char     src[]   = {"   "};
uint8_t  RCLtemp = 0;

extern uint8_t Linkxy[][LDIM];

// -----------------------------------------------------------

void csvCheck(void) {

  ReadEEPhdStrPv();

  if (EEPcheck()) { // check 2
    // EEProm check Failed
    Serial.println(F("EEProm check 2 failed, csv from Flash"));
    csvFlashRead(); // Gleisbild zeichnen, Daten aus Flash
  }
  else { // check 2
    Serial.println(F("EEProm check 2 ok, csv from EEPROM"));
    csvEEPread();    // Gleisbild zeichnen, Daten aus EEPROM
  }
} // csvCheck()


void csvEEPread(void) {                    // csv´s aus EEPROM lesen
#define STRDIM   60

  char sc            =  '\0';
  char strar[STRDIM] = {'\0'};
  int  si            =    0;
  int  EEPptr        = EEPpos;
  int  strcnt        = 0;
  static int  bytecnt       = 0;

  while (EEPROM.read(EEPptr) != 0xFF) {     // alle csv-Zeilen lesen
    for (si = 0; si < STRDIM; si++) {       // eine csv-Zeile lesen
      sc = EEPROM.read(EEPptr); EEPptr++; bytecnt++;
      if (sc == 0x0D) break;
      strar[si] = sc;
    } // for
    strcnt++;
    EEPptr++; bytecnt++; // skip LF
    strar[si] = '\0';                       // eine Zeile fertig
    csvParser(strar);
  }  // while

  Serial.print(F("CSV-lines: ")); Serial.print(strcnt);
  Serial.print(F(", Bytecnt: ")); Serial.println(bytecnt);
} // csvEEPread()


void csvFlashRead(void) {  // Zeilen aus Programm-Speicher (Flash)
  uint8_t First = 0;
  int  csvLines = 0;
  uint8_t fetch = 0;
  int         i = 0;
  int    csvPtr = 0;

  char myStr [40] = {""};
  int s = 0;

  Serial.print(F("csvLines: "));
  do {
    fetch = pgm_read_byte_near(csvStream + i);
    if ( fetch == 0x0D) csvLines++;
    i++;
  } while (fetch); // bei ungleich Null wiederholen (solange wahr)
  Serial.println(csvLines);

  csvPtr = 0;
  for (int i = 0; i < csvLines; i++) {
    s = 0;
    do {                               // einen String erzeugen
      fetch = pgm_read_byte_near(csvStream + csvPtr);
      myStr[s] = fetch; s++;
      csvPtr++;
    } while (fetch != 0x0D);
    s--;
    myStr[s] = '\0';
    csvPtr++;                          // skip LF
    Serial.println(myStr);

    First = myStr[0];

    switch (First) {                 // jede Zeile einzeln
      case '#':
        parserM(myStr);
        break;
      case '*':
        parserA(myStr);
        break;
      case '&':
        parserT(myStr);
        break;
      case 'F':
        parserF(myStr);
        break;
      default:
        strncpy(FirstLine, myStr, 3); // fuer Anzeige csv
        break;
    } // switch
  } // for
} // csvFlashRead()


void csvParser (char * csvLine) {  // Zeilen aus EEPROM
  uint8_t      First = csvLine[0];
  static bool locked = false;  // first line csv

  switch (First) { // jede Zeile einzeln
    case '#':
      parserM(csvLine);
      break;
    case '*':
      parserA(csvLine);
      break;
    case '&':
      parserT(csvLine);
      break;
    case 'F':
      parserF(csvLine);
      break;
    default:
      if (!locked) {
        strncpy(FirstLine, csvLine, 3); // fuer Anzeige csv
        locked = true;
      }
      break;
  } // switch
} // csvParser()


void  TeilParserM(char *ts) {  // Aufruf vor jedem ';' in Zeile #
  int val = 0;
  if (ts[0] == '#') { // Zeilenanfang
    val = atoi(ts + 1);
    xpos = 0;
    ypos = val;
  }
  else {    
    //Serial.print("ts, val: "); Serial.print(ts);Serial.print(' ');Serial.println(val); // ts, val: G17 0
    if (ts[0] == 'G') {                      // Gleissperre
        ts = ts + 1;
        val = atoi(ts); 
        StpM[ypos][xpos] = val | 0x80;       // Gleisplan in Matrix, Flag temorär
        ElementDraw(xpos, ypos, val | 0x80); // Gleisplan auf Bildschirm + Gsp-Flag        
    }
    else {
        val = atoi(ts);
        StpM[ypos][xpos] = val;              // Gleisplan in Matrix
        ElementDraw(xpos, ypos, val);        // Gleisplan auf Bildschirm
    }
    if (xpos > GL_xmax) GL_xmax = xpos;  // fuer Erkennung 4,3" oder 7"
    if (ypos > GL_ymax) GL_ymax = ypos;
    xpos++;
  }
} // TeilparserM()


void  TeilParserA(char *ts, byte State) {  // Aufruf vor jedem ';' in Zeile *
  // Koord., Adressen, Namen von Schaltelementen, jede * Zeile ein Element
  static byte  xko = 0;
  static byte  yko = 0;
  static int  indW = 0;
  uint16_t csvalue = 0;

  csvalue = atoi(ts);

  switch (State) {
    case 0:         // *
      break;
    case 1:         // x
      xko = csvalue;
      break;
    case 2:         // y
      yko = csvalue;
      break;
    case 3:         // Name
      TextInfo(xko, yko, ts);
      strcpy(Weiche[indW].Elstr, ts);
      break;
      
    case 4:        // Adresse in Matrix
      if (StpM[yko][xko] & 0x80) {                   // temp. Glsp-Flag
          StpM[yko][xko] = StpM[yko][xko] & 0x7F;    // Flag loeschen
          Weiche[indW].Eladress = csvalue | GLSPBIT; // MSB               
      }
      else Weiche[indW].Eladress = csvalue;
      
      StpA[yko][xko] = csvalue & ADRMASK;
      Weiche[indW].Elxkoord = xko;
      Weiche[indW].Elykoord = yko;

      // DKW, zweiter Antrieb c/d ----------------------
      switch (StpM[yko][xko] & 0x1F) {
      case 12:
      case 13:
           StpA[yko][xko] = StpA[yko][xko] | ADRZWEI; 
           Weiche[indW].ElaDKWcd = (csvalue & ADRMASK) + 1;
      }
      // -----------------------------------------------
      
      indW++;
      
      switch (StpM[yko][xko] & 0x1F) {
        case 24:                      // Doppelweiche
        case 25:
          StpA[yko][xko] = StpA[yko][xko] | ADRZWEI;
        default:
          break;
      } // switch StpM
      break; // case 4

    case 5:                                          // nur, wenn csv-Wert
      csvalue = (csvalue & 0x03) << ADRdSHT;         // Option: Umstellzeit verlaengern, 
      StpA[yko][xko] = StpA[yko][xko] | csvalue;     // 2bit, 0,1,2,3
      break; // case 5
      
    case 6:                                          // nur, wenn csv-Wert
    
      if (csvalue & 0x04) {                          // Option: DKW mit einem Antrieb 
          StpA[yko][xko] = StpA[yko][xko] | ADR1DKW; 
          StpA[yko][xko] = StpA[yko][xko] & (~ADRZWEI); // Bit rueckgängig
          }         
      if (csvalue & 0x01) {                          // Option: Schaltkmds. Swap, 1bit, 0,1
          StpA[yko][xko] = StpA[yko][xko] | ADRSWAP;
          }
      if (csvalue & 0x02) {                          // Option: Swap für DKWcd
          indW--;
          Weiche[indW].ElaDKWcd = Weiche[indW].ElaDKWcd | ADRSWAP;         
          indW++;
          }
      break;

    default:
      break;
  } // switch

} // TeilparserA()


void  TeilParserT(char *ts, byte State) {  // Aufruf vor jedem ';' in Zeile &

  static byte xko        = 0;
  static byte yko        = 0;
  static char el         = '\0';
  static char Sname[DEFDIM]  = {""};
  static int  i          = 0;     // Index, berechnet aus RM pin
  static byte Flag_z     = 0;     // Signal hat 2. Adresse (falls 1. vorhanden)
  uint8_t squareBTxt = 0;

  switch (State) {
    case 0:         // &
      break;
    case 1:  el = ts[0];  // T , S, ,B, R
      break;
    case 2:         // x
      xko = atoi(ts);
      break;
    case 3:         // y
      yko = atoi(ts);
      break;

    case 4:         // Name
      if (xko > GL_xmax) GL_xmax = xko;  // fuer Erkennung 4,3" oder 7"
      if (yko > GL_ymax) GL_ymax = yko;

      switch (el) {
        case 't': TextInfoPos(xko, yko, ts, 1, 1);
          CheckColon(ts, xko, yko);
          break;
        case 'T': TextInfo(xko, yko, ts);
          break;

        case 'S': strcpy (Sname, ts);
          break;

        case 'b': ButtonCol(xko, yko, YELLOW);
          ButtField[GL_ButtCnt].xyKo = (xko << 4) + yko;
          GL_ButtCnt++;
          //strcpy (Sname, ts);
          TextInfo(xko, yko, ts);
          break;
        case 'B': ButtField[GL_ButtCnt].xyKo = (xko << 4) + yko;
          //GL_ButtCnt++; in case 5 !
          DrawPanel(xko, yko, 0);
          //strcpy (Sname, ts);
          TextPanel(xko, yko, ts);
          break;
        case 'K': ButtField[GL_ButtCnt].xyKo = (xko << 4) + yko;
          DrawKey(xko, yko, 0, BLACK, "    "); // 5 blanks, 3.Par. 0:Taste oben, 1:Taste unten
          //strcpy (Sname, ts);
          TextInfoPos(xko, yko, ts, 4, 0);
          break;

        case 'R': i = abs(atoi(ts)) - 1;
          if (i < RMDIM) {
            RMKoord[i].x = xko;
            RMKoord[i].y = yko;
            RMmax++;
          }
          break;

        case 'i':
        case 'I': FarbfelderInit(xko, yko, ts);
          break;

        default:
          break;
      }  // switch el

      break; // case 4

    case 5:         // Element (Signaltyp), Keytype, RM-Zusatzwert
      if (el == 'S') {
        uint8_t Snumber = atoi(ts);

        StpS[yko][xko] = Snumber | 0x80;       // Signalmatrix, Hp0/Sh0

        switch (Snumber) {
          case 26:
          case 27: SigScreen (xko, yko, Snumber & 0x03);
            ShHScreen (xko, yko, Snumber & 0x03);
            Flag_z = 1;                // 2. Adresse moeglich
            break;
          case 29:
          case 28: if (Sname[0] != '*') {   
                       SigScreen (xko,yko, Snumber & 0x03);      
                       }
                       else {
                          StpS[yko][xko] = StpS[yko][xko] | 0x20; // Signal invisible                 
                       }
            break;
          case 31:
          case 30: ShScreen (xko, yko, Snumber & 0x03);
            break;
          default:
            break;
        }
        SigName(xko, yko, Sname);
      }

      if (el == 'B') {
        squareBTxt = atoi(ts) & 0xFF;
        ButtField[GL_ButtCnt].Keytype = squareBTxt;
        GL_ButtCnt++;
        if (squareBTxt == 2) { // Koord für Taste mit Wechseltext
          GL_sqExist = true;
          GL_sqButtX = xko;
          GL_sqButtY = yko;
        }
      }
      if (el == 'K') {
        ButtField[GL_ButtCnt].Keytype = atoi(ts) & 0xFF;
        GL_ButtCnt++;
      }

      if (el == 'R') {
        RMKoord[i].RevRel = (ts[0] & 0xFF); //
      }

      break; // case 5

    case 6:         // Signal Adr., Eintrag 0, wenn keine Schaltadr, fuer alle "&"
      if (el == 'S') {
        StpA[yko][xko] = atoi(ts);
        if (StpA[yko][xko]) {
          if (Flag_z) {    // wenn 1.Adr vorhanden und Sigtyp H/S dann Flag zur Adr.
            StpA[yko][xko] = StpA[yko][xko] | ADRZWEI;
            Flag_z = 0;
          }
        }
      }  // if S

      if (el == 'K') {
        StpA[yko][xko] = atoi(ts);    // Dig.Adr. fuer Schalttaste
      }
      break; // case 6

    default:
      break;
  } // switch  state
} // TeilparserT()



int   parserM(char *stri) { // Aufruf mit jeder csv-Zeile, wenn # am Anfang
  // Stellt xKoord und Num Wert da, bis Ende slen bzw. \0
  int slen = strlen(stri);
  int cnt  = 0;
  int j    = 0;
  char tstr[DEFDIM] = {""};
  int val  = 0;

  for (int i = 0; i < slen; i++) {
    if (stri[i] == ';') {
      tstr[j] = '\0';
      j = 0;
      TeilParserM(tstr);     // Teilstring fertig
      cnt++;
    }
    else {
      tstr[j] = stri[i];   // Teilstring aufbauen
      j++;
    }
  }
  return cnt;
} // parserM()


int   parserA(char *stri) { // Aufruf mit jeder csv-Zeile, wenn * am Anfang
  // ein Koord. Paar, Name, Adresse, Option Umstellzeit
  int  slen     = strlen(stri);
  int  cnt      = 0;
  int  j        = 0;
  char tstr[DEFDIM] = {""};
  int  val      = 0;
  byte StateA   = 0;

  for (int i = 0; i < slen; i++) {
    if (stri[i] == ';') {
      tstr[j] = '\0';
      j = 0;
      TeilParserA(tstr, StateA);    // Teilstring fertig
      StateA++;
      cnt++;
    }
    else {
      tstr[j] = stri[i];   // Teilstring aufbauen
      j++;
    }
  }
  return cnt;
} // parserA()


int   parserT(char *stri) { // Aufruf mit jeder csv-Zeile, wenn & am Anfang
  // ein Koord. Paar, Name und Adresse
  int  slen     = strlen(stri);
  int  cnt      = 0;
  int  j        = 0;
  char tstr[DEFDIM] = {""};
  int  val      = 0;
  byte StateA   = 0;

  for (int i = 0; i < slen; i++) {
    if (stri[i] == ';') {
      tstr[j] = '\0';
      j = 0;
      TeilParserT(tstr, StateA);    // Teilstring fertig
      StateA++;
      cnt++;
    }
    else {
      tstr[j] = stri[i];   // Teilstring aufbauen
      j++;
    }
  }
  return cnt;
} // parserT()


int   parserF(char *stri) { // Aufruf mit jeder csv-Zeile, wenn F am Anfang
  // lesen eines Fahrweges, mehrere Weichenlagen mit +/- Werten
  int  slen            = strlen(stri);
  int  cnt             = 0;
  int  j               = 0;
  char tstr[DEFDIM]    = {""};
  int  val             = 0;
  uint8_t WeichenIndex = 0;
  static uint8_t FwegIndex    = 0;

  for (int i = 0; i < slen; i++) {
    if (stri[i] == ';') { // if 1
      tstr[j] = '\0';
      j = 0;
      val = atoi(tstr);
      if (cnt) { // if 2    unterdrueckt "F"
        Fweg[FwegIndex][WeichenIndex] = val;
        WeichenIndex++;
      } // if 2
      cnt++;
    } // if 1
    else {
      tstr[j] = stri[i];   // Teilstring aufbauen
      j++;
    }
  } // for
  FwegIndex++;
  if (FwegIndex > MAXFWEG) FwegIndex = MAXFWEG;
  GL_AnzFweg = FwegIndex;
  return cnt;
} // parserF()


void CheckColon(char *str, uint8_t x, uint8_t y) {  // Link-Liste
  static uint8_t LinkArrPtr  = 0;
  int     sptr        = 0;

  if (LinkArrPtr > LDIM) return;

  if (str[0] == ':') {
    sptr = 1;
    Linkxy[0][LinkArrPtr] = x;
    Linkxy[1][LinkArrPtr] = y;
    Linkxy[2][LinkArrPtr] = atoi(str + sptr);
    if     (str[2] == ',') sptr = 3;         // einstellig
    else if (str[3] == ',') sptr = 4;        // zweistellig
    else return;
    Linkxy[3][LinkArrPtr] = atoi(str + sptr);
    LinkArrPtr++;
  }

} // CkeckColon()



uint8_t EEPcheck(void) {

  uint8_t ERRcnt = 0;
  if (hdb.hd.EEid != 0x7C2) ERRcnt++;
  for (int k = 0; k < 5; k++) {
    if ((RAM_EEPstr[k] < 0x20) || (RAM_EEPstr[k] > 0x7E)) ERRcnt++;
  }
  return ERRcnt;
} // EEPcheck()



void ReadEEPhdStrPv(void) {
  // Header
  for (int i = 0; i < hdDIM; i++) hdb.bheader[i] = EEPROM.read(i);
  // String
  for (int i = 0; i < hdDIM; i++) {
    RAM_EEPstr[i] = EEPROM.read(i + (hdDIM)); // 16 ... 31
  }
  // PV-Daten
  for (int i = 0; i < hdDIM; i++) PultPV[i] = EEPROM.read(i + (hdDIM * 2)); // 32 ... 47

} // ReadEEPhdStrPv()



void  FarbfelderInit(uint8_t xko, uint8_t yko, char *ts) {
  // Index == Option
  int i = atoi(ts);
  int Farbe = WHITE; // default

  Melder[i].x = xko;
  Melder[i].y = yko;
  Melder[i].exist = true; // Melder Box nicht an default-Position

  switch (i) {
    case 1: FeldFarbe(xko, yko, KAKI);
      TextInfoPos(xko, yko, "Run", 3, 3);
      TextInfoPos(xko, yko, "TFdb", 2, 2);
      break;

    case 2: FeldFarbe(xko, yko, KAKI);
      //CircleF (xko, yko, 6,DGRAY);  // Ring, Blink
      TextInfoPos(xko, yko, "Busy", 3, 3);
      TextInfoPos(xko, yko, "TPwr", 2, 2);
      break;

    case 3: FeldFarbe(xko, yko, LBLUE);
            TextPanel(xko, yko, "a/b");
      break;

    case 4: FeldFarbe(xko, yko, EXPGN);     // route class, Fahrwegoptionen

      TextPanel(xko, yko, src);

      RCLtemp = EEPROM.read(RCLeep);
      if (RCLtemp > RCMAX) {          // wg. EEP leer
        RCLtemp = 0;
        EEPROM.write(RCLeep, RCLtemp);
      }
      GL_RouteClass = RCLtemp;
      src[1] = RCLtemp | 0x30;

      TextPanel(xko, yko, src);
      TextInfoPos(xko, yko, "Route CL", 5, 4);
      break;

    case 5: FeldFarbe(xko, yko, BLROT);   // info, tbd Rot blass, Signal z.B. Hp/Sh-Wahl
      TextPanel(xko, yko, " Z ");
      break;

    case 6:                 // info, csv, SW Version, ggf. unten Texte
      TextInfoPos(xko, yko, ">", 5, 0);
      break;

    case 0:
    default:
      break;
  } // switch
} // FarbfelderInit()
